<?php

namespace Application\Db;
use ZendServer\FS\FS;

use ZendServer\Log\Log;

use PDO;
class SqliteDbCreator {
	const DATABASE_GUI_FILENAME = 'gui_sqlite_create_database.sql';
	const DATABASE_GUI_ACL_FIXTURES_FILENAME = 'gui_sqlite_acl_fixtures.sql';
	/**
	 * @var PDO
	 */
	private $pdo;
	public function __construct($pdo) {
		$this->pdo = $pdo;
	}
	
	public function createGuiDb() {
		
		$installDir = get_cfg_var('zend.install_dir');
		
		$files = array(self::DATABASE_GUI_FILENAME, self::DATABASE_GUI_ACL_FIXTURES_FILENAME);
		
		$this->pdo->exec('BEGIN TRANSACTION');
		foreach ($files as $filename) {
			$schemaPath = FS::createPath($installDir, 'share', $filename);
			$schemaFile = FS::getFileObject($schemaPath);

			Log::info('Executing queries from ' . $schemaFile->getFilename());
			$queries = explode(';', $schemaFile->readAll());
			foreach ($queries as $query) {
				if ($query = trim($query)) {
					Log::debug("Execute query '{$query}'");
					$this->pdo->exec($query);
				}
			}
		}
		$this->pdo->exec('COMMIT TRANSACTION');
		
	}
	
}

