<?php

namespace Application\View\Helper;

use Zend\Form\View\Helper\AbstractHelper;
use Zend\Uri\UriFactory;
class HelpLink extends AbstractHelper {
	
	public function __invoke($helpHash = null) {		
		$helpBase = 'http://files.zend.com/help/Zend-Server-6/zend-server.htm#';
		
		if (! is_null($helpHash)) {
			return $helpBase . $helpHash . '.htm';
		}
		
		$path = UriFactory::factory($_SERVER["REQUEST_URI"])->getPath();
		if (preg_match('/^Index/', basename($path))) { // in some cases the basename of the path is starting with Index, in which case we will ignore that part
			$path = dirname($path);
		}		
		
		$firstName = basename(dirname($path));
		$baseName = basename($path);		
		if ($firstName == 'ZendServer') {
			$pageName = $baseName;
		} else {
			$pageName = $firstName.'_'.$baseName;
		}
		
		if ($pageName == '_ZendServer') {
			$pageName = '';
		}
		
		if($pageName != ''){
			$helpPageName = strtolower(preg_replace('/([a-z])([A-Z])/', '$1_$2', $pageName));
			$helpLink = $helpBase . $helpPageName . '.htm';
		} else {
			$helpLink = $helpBase . 'dashboard.htm';
		}
		
		return $helpLink;
	}
}

