<?php

namespace Snapshots\Mapper;

use ZendServer\Log\Log;
use ZendServer\Exception;

class Profile {
	/**
	 * @var \Zsd\Db\TasksMapper
	 */
	private $tasksMapper;
	
	/**
	 * @var array
	 */
	private $profiles;
	
	public function activateProfile($profile) {
		
		if (isset($this->profiles[$profile])) {
			Log::info("will set {$profile} directives");
			$directives = array();
			
			foreach ($this->profiles[$profile] as $key=>$sectionData) { /* @var $sectionData \Zend\Config\Config */				
				if ($key === 'GUI') {					
					$this->getTasksMapper()->setGuiDirectives($sectionData->toArray());
				} elseif ($key === 'PHP_53' && version_compare(phpversion(), '5.4.0', '<')) {
					$directives = array_merge($directives, $sectionData->toArray());
				} elseif ($key === 'PHP_54' && version_compare(phpversion(), '5.4.0', '>')) {
					$directives = array_merge($directives, $sectionData->toArray());
				} else { // ZEND, PHP_ALL
					$directives = array_merge($directives, $sectionData->toArray());
				}
			}
			$this->getTasksMapper()->setDirectives($directives);
		} else {
			throw new Exception(_t('Profile "%s" does not exist', array($profile)));
		}
	}
	
	/**
	 * @return \Zsd\Db\TasksMapper
	 */
	public function getTasksMapper() {
		return $this->tasksMapper;
	}

	/**
	 * @return array
	 */
	public function getProfiles() {
		return $this->profiles;
	}

	/**
	 * @param multitype: $profiles
	 */
	public function setProfiles($profiles) {
		$this->profiles = $profiles;
	}

	/**
	 * @param \Zsd\Db\TasksMapper $tasksMapper
	 */
	public function setTasksMapper($tasksMapper) {
		$this->tasksMapper = $tasksMapper;
	}

}

