<?php

namespace Codetracing;

use ZendServer\Edition;

use Zend\ModuleManager\Feature\ServiceProviderInterface;

use Zend\ModuleManager\Feature\AutoloaderProviderInterface as AutoloaderProvider;

class Module implements AutoloaderProvider, ServiceProviderInterface
{
	
	public function getServiceConfig() {
		return array(
			'factories' => array(
				'Codetracing\Model' => function($sm) {
					$model = new Model();
					$model->setDirectivesMapper($sm->get('Configuration\MapperDirectives'));
					return $model;
				},
				'Codetracing\TraceFilesMapper' => function($sm) {
				
					$mapper = new TraceFilesMapper();
					$mapper->setTableGateway($sm->get('traceFiles_tg'));
					
					return $mapper;
				},
				'Codetracing\Trace\AmfFileRetriever' => function($sm) {
				
					$retriever = new Trace\AmfFileRetriever();
					$retriever->setWebapiKeyMapper($sm->get('WebAPI\Db\Mapper'));
					$retriever->setWrapper($sm->get('Codetracing\Dump\Wrapper'));
					$retriever->setServersMapper($sm->get('Servers\Db\Mapper'));
					
					return $retriever;
				}
			)
		);
	}
	
	public function getAutoloaderConfig()
	{
		return array(
				'Zend\Loader\StandardAutoloader' => array(
						'namespaces' => array(
								__NAMESPACE__ => __DIR__ . '/src/' . __NAMESPACE__,
						),
				),
		);
	}
	
	public function getConfig()
	{
		return include __DIR__ . '/config/module.config.php';
	}
}
