<?php
namespace Codetracing\View\Helper;

use Zend\View\Helper\AbstractHelper;

class TraceFileXml extends AbstractHelper {
	
	public function __invoke(\Codetracing\TraceFileContainer $trace) {
	
		$route = $trace->getRouteDetails();
		if (isset($route['controller'])) {
			$routeStr = $route['controller'] . " | " . $route['action'];
		} else {
			$routeStr = "";
		}
		
		return <<<XML
<codeTrace>
	<id>{$trace->getId()}</id>
	<date>{$this->getView()->webapiDate($trace->getDate())}</date>
	<timestamp>{$trace->getDate()}</timestamp>
	<url>{$this->getView()->escapeHtml($trace->getUrl())}</url>
	<createdBy>{$trace->getReason()}</createdBy>
	<fileSize>{$trace->getTraceSize()}</fileSize>
	<applicationId>{$trace->getApplicationId()}</applicationId>
	<nodeId>{$trace->getNodeId()}</nodeId>
	<routeDetails>$routeStr</routeDetails>
</codeTrace>
XML;
	}

}

