<?php

namespace Configuration\Controller;

use ZendServer\Mvc\Controller\ActionController,
Application\Module;

class ZendComponentsController extends ActionController {
	
	const COMPONENT_ZEND_OPTIMIZER = 'Zend Optimizer+';
	const COMPONENT_ZEND_DATA_CACHE = 'Zend Data Cache';
	const COMPONENT_ZEND_PAGE_CACHE = 'Zend Page Cache';
	
	public function indexAction() {	
	    $acl = $this->getLocator('ZendServerAcl'); /* @var $acl \Zend\Acl\Acl */
	    $isAllowedToSaveDirectives = $acl->isAllowed('route:ConfigurationWebApi', 'configurationStoreDirectives');
	    $isAllowedToEnable = $acl->isAllowed('route:ConfigurationWebApi', 'configurationExtensionsOn');
	    $isAllowedToDisable = $acl->isAllowed('route:ConfigurationWebApi', 'configurationExtensionsOff');
	    
	    $componentsView = $this->forward()->dispatch('ConfigurationWebApi-1_3', array('action' => 'configurationComponentsList')); /* @var $componentsView \Zend\View\Model\ViewModel */
		$componentsView->setTemplate('configuration/zend-components/index');// Restoring original route
		$componentsView->setVariable('isAllowedToSaveDirectives', $isAllowedToSaveDirectives);
		$componentsView->setVariable('isAllowedToEnable', $isAllowedToEnable);
		$componentsView->setVariable('isAllowedToDisable', $isAllowedToDisable);

		return $componentsView;
	}
}

