<?php
namespace Configuration;

require_once 'tests/bootstrap.php';
require_once 'MapperAbstractTest.php';

class MapperExtensionsTest extends MapperAbstractTest {
	
	protected $testedTable = 'ZSD_EXTENSIONS';
	
	public function testselectAllExtensions() {		
		$res = $this->getConnection()->query("SELECT * FROM " . $this->getTableName());
		$rows = $res->fetchAll();
		
		$this->assertEquals(sizeof($this->getRows()), sizeof($this->getTestedMapper()->selectAllExtensions()), "selectAllExtensionsCount1");
		$this->assertEquals(sizeof($this->getRows()), sizeof($rows), "selectAllExtensionsCount2");
	}

	public function testselectAllZendExtensions() {
		$res = $this->getConnection()->query("SELECT * FROM " . $this->getTableName() . ' WHERE "IS_ZEND_COMPONENT"="1"');
		$rows = $res->fetchAll();
	
		$this->assertEquals(2, sizeof($this->getTestedMapper()->selectAllZendExtensions()), "selectAllZendExtensionsCount1");
		$this->assertEquals(2, sizeof($rows), "selectAllZendExtensionsCount2");
	}

	public function testselectAllPHPExtensions() {
		$res = $this->getConnection()->query("SELECT * FROM " . $this->getTableName() . ' WHERE "IS_ZEND_COMPONENT"="0"');
		$rows = $res->fetchAll();
	
		$this->assertEquals(3, sizeof($this->getTestedMapper()->selectAllPHPExtensions()), "selectAllPHPExtensionsCount1");
		$this->assertEquals(3, sizeof($rows), "selectAllPHPExtensionsCount2");
	}
	

	/**
	 * @return MapperExtensions
	 */
	protected function getTestedMapper() {
		if ($this->testedMapper) return $this->testedMapper;
			
		return $this->testedMapper = new MapperExtensions();
	}
	
	protected function getRows() {
		return array(				
			// RELYING ON STRUCT FOUND IN getTableColumns()
			'Core'=>'"Core","5.3.9-ZS5.6.0","1","1","","0"',
			'pdo_sqlite'=>'"pdo_sqlite","1.0.1","1","1","pdo_sqlite.ini","0"',
			'ncurses'=>'"ncurses","","0","0","ncurses.ini","0"',	
			'Zend Data Cache'=>'"Zend Data Cache","null","1","1","datacache.ini","1"',			
			'Zend Java Bridge'=>'"Zend Java Bridge","","0","0","jbridge.ini","1"',				
		);
	}
	
	protected function getTableColumns() {
		return 'NAME,EXT_VERSION,IS_INSTALLED,IS_LOADED,INI_FILE,IS_ZEND_COMPONENT';		
	}

}
