<?php
return array(
	'allowedWebAPIActions' => array(
			'DeploymentWebAPI' => array('applicationDeploy','applicationGetStatus', 'applicationRemove','applicationUpdate'),
			'DeploymentLibraryWebAPI' => array('libraryGetStatus','libraryVersionGetStatus', 'libraryVersionDeploy','libraryVersionRemove', 'downloadLibraryVersionFile'),
	),
	'dependencies' => array(
		'extensions' => array(
			'Zip' => array(),
		),
	),
		'view_helpers' => array(
				'invokables' => array(
				'appStatus' => 'Deployment\View\Helper\AppStatus',
				'appHealthCheckStatus' => 'Deployment\View\Helper\AppHealthCheckStatus',
				'appDetails' => 'Deployment\View\Helper\AppDetails',
				'appPrerequisites' => 'Deployment\View\Helper\AppPrerequisites',
				'appPrerequisitesJson' => 'Deployment\View\Helper\AppPrerequisitesJson',
				'appMessages' => 'Deployment\View\Helper\AppMessages',
				'AppLogo' => 'Deployment\View\Helper\AppLogo',
				'ApplicationInfoJson' => 'Deployment\View\Helper\ApplicationInfoJson',
				'ApplicationInfoXml' => 'Deployment\View\Helper\ApplicationInfoXml',
				'ZGridApplicationInfo' => 'Deployment\View\Helper\ZGridApplicationInfo',
				'LibraryInfoJson' => 'DeploymentLibrary\View\Helper\LibraryInfoJson',
				'LibraryVersionInfoJson' => 'DeploymentLibrary\View\Helper\LibraryVersionInfoJson',
				'LibraryInfoXml' => 'DeploymentLibrary\View\Helper\LibraryInfoXml',
				'LibraryVersionInfoXml' => 'DeploymentLibrary\View\Helper\LibraryVersionInfoXml',
				'LibraryVersionServerInfoXml' => 'DeploymentLibrary\View\Helper\LibraryVersionServerInfoXml',
				'LibraryVersionServerInfoJson' => 'DeploymentLibrary\View\Helper\LibraryVersionServerInfoJson',
				'libStatus' => 'DeploymentLibrary\View\Helper\LibStatus',
				'normalizeStatus' => 'DeploymentLibrary\View\Helper\NormalizeStatus',
				'normalizeUpdateUrl' => 'DeploymentLibrary\View\Helper\NormalizeUpdateUrl',
				'libraryUpdateCheck' => 'DeploymentLibrary\View\Helper\LibraryUpdateCheck',
						)
		),
	'controllers' => array(
		'invokables' => array(
                'DeploymentLibrary' => 'DeploymentLibrary\Controller\IndexController',
                'Deployment' => 'Deployment\Controller\IndexController',
                'DeploymentWebAPI-1_3' => 'Deployment\Controller\WebAPIController',
                'DeploymentWebAPI-1_2' => 'Deployment\Controller\WebAPIController',
                'DeploymentLibraryWebAPI-1_5' => 'DeploymentLibrary\Controller\WebAPIController',
            	'Wizard' => 'Deployment\Controller\WizardController',
            	'LibraryWizard' => 'DeploymentLibrary\Controller\WizardController',
            	'DefineWizard' => 'Deployment\Controller\DefineWizardController',
		),
	),
	'view_manager' => array(
		
		'template_path_stack' => array(
				__DIR__ . '/../views',
		),
	),
    'webapi_routes' => array(
        'libraryGetStatus' => array(
                'type'    => 'Zend\Mvc\Router\Http\Literal',
                'options' => array(
                        'route'    => '/Api/libraryGetStatus',
                        'defaults' => array(
                                'controller' => 'DeploymentLibraryWebAPI',
                                'action'     => 'libraryGetStatus',
                                'versions'	 => array('1.5')
                        ),
                ),
        ),
        'libraryVersionCheckDependents' => array(
                'type'    => 'Zend\Mvc\Router\Http\Literal',
                'options' => array(
                        'route'    => '/Api/libraryVersionCheckDependents',
                        'defaults' => array(
                                'controller' => 'DeploymentLibraryWebAPI',
                                'action'     => 'libraryVersionCheckDependents',
                                'versions'	 => array('1.5')
                        ),
                ),
        ),
        'libraryCheckDependents' => array(
                'type'    => 'Zend\Mvc\Router\Http\Literal',
                'options' => array(
                        'route'    => '/Api/libraryCheckDependents',
                        'defaults' => array(
                                'controller' => 'DeploymentLibraryWebAPI',
                                'action'     => 'libraryCheckDependents',
                                'versions'	 => array('1.5')
                        ),
                ),
        ),
    	'libraryVersionGetStatus' => array(
    			'type'    => 'Zend\Mvc\Router\Http\Literal',
    			'options' => array(
    					'route'    => '/Api/libraryVersionGetStatus',
    					'defaults' => array(
    							'controller' => 'DeploymentLibraryWebAPI',
    							'action'     => 'libraryVersionGetStatus',
    							'versions'	 => array('1.5')
    					),
    			),
    	),
    	'downloadLibraryVersionFile' => array(
    			'type'    => 'Zend\Mvc\Router\Http\Literal',
    			'options' => array(
    					'route'    => '/Api/downloadLibraryVersionFile',
    					'defaults' => array(
    							'controller' => 'DeploymentLibraryWebAPI',
    							'action'     => 'downloadLibraryVersionFile',
    							'versions'	 => array('1.5')
    					),
    			),
    	),
    	'libraryVersionRemove' => array(
    			'type'    => 'Zend\Mvc\Router\Http\Literal',
    			'options' => array(
    					'route'    => '/Api/libraryVersionRemove',
    					'defaults' => array(
    							'controller' => 'DeploymentLibraryWebAPI',
    							'action'     => 'libraryVersionRemove',
    							'versions'	 => array('1.5')
    					),
    			),
    	),
    	'libraryRemove' => array(
    			'type'    => 'Zend\Mvc\Router\Http\Literal',
    			'options' => array(
    					'route'    => '/Api/libraryRemove',
    					'defaults' => array(
    							'controller' => 'DeploymentLibraryWebAPI',
    							'action'     => 'libraryRemove',
    							'versions'	 => array('1.5')
    					),
    			),
    	),
    	'libraryVersionSynchronize' => array(
    			'type'    => 'Zend\Mvc\Router\Http\Literal',
    			'options' => array(
    					'route'    => '/Api/libraryVersionSynchronize',
    					'defaults' => array(
    							'controller' => 'DeploymentLibraryWebAPI',
    							'action'     => 'libraryVersionSynchronize',
    							'versions'	 => array('1.5')
    					),
    			),
    	),
    	'libraryVersionDeploy' => array(
    			'type'    => 'Zend\Mvc\Router\Http\Literal',
    			'options' => array(
    					'route'    => '/Api/libraryVersionDeploy',
    					'defaults' => array(
    							'controller' => 'DeploymentLibraryWebAPI',
    							'action'     => 'libraryVersionDeploy',
    							'versions'	 => array('1.5')
    					),
    			),
    	),
        'applicationGetDetails' => array(
                'type'    => 'Zend\Mvc\Router\Http\Literal',
                'options' => array(
                        'route'    => '/Api/applicationGetDetails',
                        'defaults' => array(
                                'controller' => 'DeploymentWebAPI',
                                'action'     => 'applicationGetDetails',
                                'versions'	 => array('1.3')
                        ),
                ),
        ),
        'redeployAllApplications' => array(
                'type'    => 'Zend\Mvc\Router\Http\Literal',
                'options' => array(
                        'route'    => '/Api/redeployAllApplications',
                        'defaults' => array(
                                'controller' => 'DeploymentWebAPI',
                                'action'     => 'redeployAllApplications',
                                'versions'	 => array('1.3')
                        ),
                ),
        ),
    	'applicationDefine' => array(
    			'type'    => 'Zend\Mvc\Router\Http\Literal',
    			'options' => array(
    					'route'    => '/Api/applicationDefine',
    					'defaults' => array(
    							'controller' => 'DeploymentWebAPI',
    							'action'     => 'applicationDefine',
    							'versions'	 => array('1.3')
    					),
    			),
    	),
        'deployDemoApplication' => array(
                'type'    => 'Zend\Mvc\Router\Http\Literal',
                'options' => array(
                        'route'    => '/Api/deployDemoApplication',
                        'defaults' => array(
                                'controller' => 'DeploymentWebAPI',
                                'action'     => 'deployDemoApplication',
                                'versions'	 => array('1.3')
                        ),
                ),
        ),
    	'applicationDeploy' => array(
    			'type'    => 'Zend\Mvc\Router\Http\Literal',
    			'options' => array(
    					'route'    => '/Api/applicationDeploy',
    					'defaults' => array(
    							'controller' => 'DeploymentWebAPI',
    							'action'     => 'applicationDeploy',
    							'versions'	 => array('1.2'),
    							'viewsmap'   => array('1.2' => '1.3')
    					),
    			),
    	),
        'applicationGetStatus' => array(
                'type'    => 'Zend\Mvc\Router\Http\Literal',
                'options' => array(
                        'route'    => '/Api/applicationGetStatus',
                        'defaults' => array(
                                'controller' => 'DeploymentWebAPI',
                                'action'     => 'applicationGetStatus',
                                'versions'	 => array('1.2'),
                        		'viewsmap'	=> array('1.2' => '1.3')
                        ),
                ),
        ),
    	'applicationUpdate' => array(
    		'type'    => 'Zend\Mvc\Router\Http\Literal',
    		'options' => array(
    			'route'    => '/Api/applicationUpdate',
    			'defaults' => array(
    				'controller' => 'DeploymentWebAPI',
    				'action'     => 'applicationUpdate',
    				'versions'	 => array('1.2'),
    				'viewsmap'   => array('1.2' => '1.3')
    			),
    		),
    	),
        'applicationSynchronize' => array(
            'type'    => 'Zend\Mvc\Router\Http\Literal',
            'options' => array(
                    'route'    => '/Api/applicationSynchronize',
                    'defaults' => array(
                            'controller' => 'DeploymentWebAPI',
                            'action'     => 'applicationSynchronize',
                            'versions'	 => array('1.2'),
    						'viewsmap'   => array('1.2' => '1.3')
                    ),
            ),
        ),
        'applicationRemove' => array(
            'type'    => 'Zend\Mvc\Router\Http\Literal',
            'options' => array(
                    'route'    => '/Api/applicationRemove',
                    'defaults' => array(
                            'controller' => 'DeploymentWebAPI',
                            'action'     => 'applicationRemove',
                            'versions'	 => array('1.2'),
                    		'viewsmap'	=> array('1.2' => '1.3')
                    ),
            ),
        ),
    	'changeApplicationName' => array(
    			'type'    => 'Zend\Mvc\Router\Http\Literal',
    			'options' => array(
    					'route'    => '/Api/changeApplicationName',
    					'defaults' => array(
    							'controller' => 'DeploymentWebAPI',
    							'action'     => 'changeApplicationName',
    							'versions'	 => array('1.3')
    					),
    			),
    	),
        'applicationRollback' => array(
                'type'    => 'Zend\Mvc\Router\Http\Literal',
                'options' => array(
                        'route'    => '/Api/applicationRollback',
                        'defaults' => array(
                                'controller' => 'DeploymentWebAPI',
                                'action'     => 'applicationRollback',
                                'versions'	 => array('1.2'),
                    		'viewsmap'	=> array('1.2' => '1.3')
                        ),
                ),
        ),
    	'applicationCancelPendingDeployment' => array(
    			'type'    => 'Zend\Mvc\Router\Http\Literal',
    			'options' => array(
    					'route'    => '/Api/applicationCancelPendingDeployment',
    					'defaults' => array(
    							'controller' => 'DeploymentWebAPI',
    							'action'     => 'applicationCancelPendingDeployment',
    							'versions'	 => array('1.3')
    					),
    			),
    	),
    ),
);
