<?php
return array(
		'view_helpers' => array(
				'invokables' => array(
				'jobDataJson' => 'JobQueue\View\Helper\JobDataJson',
				'jobJson' => 'JobQueue\View\Helper\JobJson',
				'jobDataXml' => 'JobQueue\View\Helper\JobDataXml',
				'jobXml' => 'JobQueue\View\Helper\JobXml',
				'jobDetailsCronToHuman' => 'JobQueue\View\Helper\JobDetailsCronToHuman',
				'jobsRuleXml' => 'JobQueue\View\Helper\RuleXml',
				'jobsRuleJson' => 'JobQueue\View\Helper\RuleJson',
				'jobsRuleDataXml' => 'JobQueue\View\Helper\RuleDataXml',
				'jobsRuleDataJson' => 'JobQueue\View\Helper\RuleDataJson',
						)
		),
	'controllers' => array(
		'invokables' => array(
        	'JobQueue' => 'JobQueue\Controller\IndexController',
		    'RecurringJobs' => 'JobQueue\Controller\RecurringJobsController',
			'JobQueueWebApi-1_3' => 'JobQueue\Controller\WebAPIController',
		),
	),
	'view_manager' => array(
		
		'template_path_stack' => array(
				__DIR__ . '/../views',
		),
	),
    'di' => array(
        'instance' => array(
        	'alias' => array(
        		'jq_dictionary' => 'JobQueue\Filter\Dictionary',
        		'jobqueueJobs_tg' => 'Zend\Db\TableGateway\TableGateway',
        		'jobqueueRules_tg' => 'Zend\Db\TableGateway\TableGateway',
        		'jobqueueDbAdapter' => 'Zend\Db\Adapter\Adapter',
        		'jobqueueDbDriver' => 'Zend\Db\Adapter\Driver\Pdo\Pdo',
        		'jobqueueDbPDO' => 'PDO',
        	),
        		
        	'JobQueue\Model\Mapper' => array(),
        	
        	'JobQueue\Db\Mapper' => array(
        		'parameters' => array(
        				'tableGateway' =>  'jobqueueJobs_tg',
//         				'rulesGateway' => 'jobqueueRules_tg'
        		)
        	),
    		'jobqueueJobs_tg' => array (
    				'parameters' => array(
    						'table' => 'jobqueue_job',
    						'adapter' => 'jobqueueDbAdapter',
    				)    				
    		),
			'jobqueueRules_tg' => array (
					'parameters' => array(
							'table' => 'jobqueue_schedule',
							'adapter' => 'jobqueueDbAdapter',
					)
			),
        		
        	'jobqueueDbAdapter' => array(
        			'parameters' => array(
        					'driver' => 'jobqueueDbDriver',
        			)
        	),
        			
        	'jobqueueDbDriver' => array(
        			'parameters' => array(
        					'connection' => 'jobqueueDbPDO',
        			)
        	),
        			
        	'jobqueueDbPDO' => array(
        			'parameters' => array(
        					'context' => 'jobqueue',
        			)
        	),
        ),
	),
	'webapi_routes' => array(
		'jobqueueStatistics' => array(
				'type'	=> 'Zend\Mvc\Router\Http\Literal',
				'options' => array(
						'route'	=> '/Api/jobqueueStatistics',
						'defaults' => array(
								'controller' => 'JobQueueWebApi',
								'action'	 => 'jobqueueStatistics',
								'versions'	 => array('1.3')
						),
				),
		),
		'jobqueueSaveRule' => array(
				'type'	=> 'Zend\Mvc\Router\Http\Literal',
				'options' => array(
						'route'	=> '/Api/jobqueueSaveRule',
						'defaults' => array(
								'controller' => 'JobQueueWebApi',
								'action'	 => 'jobqueueSaveRule',
								'versions'	 => array('1.3')
						),
				),
		),
		'jobqueueRunNowRule' => array(
				'type'	=> 'Zend\Mvc\Router\Http\Literal',
				'options' => array(
						'route'	=> '/Api/jobqueueRunNowRule',
						'defaults' => array(
								'controller' => 'JobQueueWebApi',
								'action'	 => 'jobqueueRunNowRule',
								'versions'	 => array('1.3')
						),
				),
		),
		'jobqueueDeleteJobsByPredefinedFilter' => array(
				'type'	=> 'Zend\Mvc\Router\Http\Literal',
				'options' => array(
					'route'	=> '/Api/jobqueueDeleteJobsByPredefinedFilter',
					'defaults' => array(
							'controller' => 'JobQueueWebApi',
							'action'	 => 'jobqueueDeleteJobsByPredefinedFilter',
							'versions'	 => array('1.3')
					),
				),
		),
		'jobqueueJobsList' => array(
				'type'	=> 'Zend\Mvc\Router\Http\Literal',
				'options' => array(
						'route'	=> '/Api/jobqueueJobsList',
						'defaults' => array(
								'controller' => 'JobQueueWebApi',
								'action'	 => 'jobqueueJobsList',
								'versions'	 => array('1.3')
						),
				),
		),
		'jobqueueDeleteJobs' => array(
				'type'	=> 'Zend\Mvc\Router\Http\Literal',
				'options' => array(
						'route'	=> '/Api/jobqueueDeleteJobs',
						'defaults' => array(
								'controller' => 'JobQueueWebApi',
								'action'	 => 'jobqueueDeleteJobs',
								'versions'	 => array('1.3')
						),
				),
		),
		'jobqueueRequeueJobs' => array(
				'type'	=> 'Zend\Mvc\Router\Http\Literal',
				'options' => array(
						'route'	=> '/Api/jobqueueRequeueJobs',
						'defaults' => array(
								'controller' => 'JobQueueWebApi',
								'action'	 => 'jobqueueRequeueJobs',
								'versions'	 => array('1.3')
						),
				),
		),
		'jobqueueJobInfo' => array(
				'type'	=> 'Zend\Mvc\Router\Http\Literal',
				'options' => array(
						'route'	=> '/Api/jobqueueJobInfo',
						'defaults' => array(
								'controller' => 'JobQueueWebApi',
								'action'	 => 'jobqueueJobInfo',
								'versions'	 => array('1.3')
						),
				),
		),
		'jobqueueResumeRules' => array(
				'type'	=> 'Zend\Mvc\Router\Http\Literal',
				'options' => array(
						'route'	=> '/Api/jobqueueResumeRules',
						'defaults' => array(
								'controller' => 'JobQueueWebApi',
								'action'	 => 'jobqueueResumeRules',
								'versions'	 => array('1.3')
						),
				),
		),
		'jobqueueDisableRules' => array(
				'type'	=> 'Zend\Mvc\Router\Http\Literal',
				'options' => array(
						'route'	=> '/Api/jobqueueDisableRules',
						'defaults' => array(
								'controller' => 'JobQueueWebApi',
								'action'	 => 'jobqueueDisableRules',
								'versions'	 => array('1.3')
						),
				),
		),
		'jobqueueRulesList' => array(
				'type'	=> 'Zend\Mvc\Router\Http\Literal',
				'options' => array(
						'route'	=> '/Api/jobqueueRulesList',
						'defaults' => array(
								'controller' => 'JobQueueWebApi',
								'action'	 => 'jobqueueRulesList',
								'versions'	 => array('1.3')
						),
				),
		),
		'jobqueueRuleInfo' => array(
				'type'	=> 'Zend\Mvc\Router\Http\Literal',
				'options' => array(
						'route'	=> '/Api/jobqueueRuleInfo',
						'defaults' => array(
								'controller' => 'JobQueueWebApi',
								'action'	 => 'jobqueueRuleInfo',
								'versions'	 => array('1.3')
						),
				),
		),
		'jobqueueDeleteRules' => array(
				'type'	=> 'Zend\Mvc\Router\Http\Literal',
				'options' => array(
						'route'	=> '/Api/jobqueueDeleteRules',
						'defaults' => array(
								'controller' => 'JobQueueWebApi',
								'action'	 => 'jobqueueDeleteRules',
								'versions'	 => array('1.3')
						),
				),
		),
	),
);
