<?php

namespace StudioIntegration;

use Application\Module as appModule;

use Zend\ModuleManager\Feature\AutoloaderProviderInterface as AutoloaderProvider;
use Zend\ModuleManager\Feature\ServiceProviderInterface;


class Module implements AutoloaderProvider, ServiceProviderInterface
{
	
	public function getAutoloaderConfig()
	{
		return array(
				'Zend\Loader\StandardAutoloader' => array(
						'namespaces' => array(
								__NAMESPACE__ => __DIR__ . '/src/' . __NAMESPACE__,
						),
				),
		);
	}
	
	public function getConfig()
	{
		return include __DIR__ . '/config/module.config.php';
	}	
	
	/*
	 * (non-PHPdoc)
	* @see \Zend\ModuleManager\Feature\ServiceProviderInterface::getServiceConfig()
	*/
	public function getServiceConfig() {
		$module = $this;
		return array(
				'factories' => array(
						'StudioIntegration\Mapper' => function($sm) {
							$mapper = new Mapper();
							$mapper->setModuleConfiguration(appModule::config('studioIntegration')->toArray());
							return $mapper;
						},
						'StudioIntegrationModel' => function($sm) {
							$model = new \StudioIntegration\Model();
							$model->setDebuggerWrapper(new \StudioIntegration\Debugger\Wrapper());
							appModule::config('studioIntegration', 'alternateDebugServer');
							return $model;
						},
						'StudioIntegration\exportIssue' => function($sm) {
							$exportIssue = new exportIssue($sm->get('MonitorUi\Model\Model'));
							$exportIssue->setcodetracingModel($sm->get('Codetracing\Model'));
							return $exportIssue;
						}		
				),
		);
	}	
	
	
}
