<?php
return array(
	'allowedWebAPIActions' => array(
			'StudioWebApi' => array(	'studioIsDebugModeEnabled','monitorExportIssueByEventsGroup','studioStartDebugMode','studioStopDebugMode',
										'saveAlternateServer', 'studioStartDebug', 'studioStartProfile', 'studioShowSourceAction'),
	),
	'controllers' => array(
		'invokables' => array(
			'StudioWebApi-1_3' => 'StudioIntegration\Controller\WebAPIController',
			'StudioWebApi-1_2' => 'StudioIntegration\Controller\WebAPIController',
			'StudioIntegration' => 'StudioIntegration\Controller\IndexController',
		)
	),
	'view_helpers' => array(
			'invokables' => array(
				'formHostsList' => 'StudioIntegration\Form\View\Helper\HostsList'
			)),
	'view_manager' => array(
		'template_path_stack' => array(
				__DIR__ . '/../views',
		),
	),
	'di' => array(
		'instance' => array(
			'alias' => array(
				'StudioIntegrationConfiguration' => 'StudioIntegration\Configuration',		
				'StudioMonitorIssueGroupData' => 'StudioIntegration\MonitorIssueGroupData',
			),
		)
	),
	'webapi_routes' => array(
		'saveAlternateServer' => array(
				'type'	=> 'Zend\Mvc\Router\Http\Literal',
				'options' => array(
						'route'	=> '/Api/saveAlternateServer',
						'defaults' => array(
								'controller' => 'StudioWebApi',
								'action'	 => 'saveAlternateServer',
								'versions'	 => array('1.3')
						),
				),
		),
		'studioStartDebug' => array(
			'type'	=> 'Zend\Mvc\Router\Http\Literal',
			'options' => array(
				'route'	=> '/Api/studioStartDebug',
				'defaults' => array(
					'controller' => 'StudioWebApi',
					'action'	 => 'studioStartDebug',
					'versions'	 => array('1.2'),
					'viewsmap'	=> array('1.2' => '1.3')
				),
			),
		),
		'studioStartProfile' => array(
			'type'	=> 'Zend\Mvc\Router\Http\Literal',
			'options' => array(
				'route'	=> '/Api/studioStartProfile',
				'defaults' => array(
					'controller' => 'StudioWebApi',
					'action'	 => 'studioStartProfile',
					'versions'	 => array('1.2'),
					'viewsmap'	=> array('1.2' => '1.3')
				),
			),
		),
		'studioShowSourceAction' => array(
				'type'	=> 'Zend\Mvc\Router\Http\Literal',
				'options' => array(
						'route'	=> '/Api/studioShowSource',
						'defaults' => array(
								'controller' => 'StudioWebApi',
								'action'	 => 'studioShowSource',
								'versions'	 => array('1.3')
						),
				),
		),
		'monitorExportIssueByEventsGroupAction' => array(
			'type'	=> 'Zend\Mvc\Router\Http\Literal',
			'options' => array(
				'route'	=> '/Api/monitorExportIssueByEventsGroup',
				'defaults' => array(
					'controller' => 'StudioWebApi',
					'action'	 => 'monitorExportIssueByEventsGroup',
					'versions'	 => array('1.2'),
					'viewsmap'	=> array('1.2' => '1.3')
				),
			),
		),		
		'studioStartDebugMode' => array(
				'type'	=> 'Zend\Mvc\Router\Http\Literal',
				'options' => array(
						'route'	=> '/Api/studioStartDebugMode',
						'defaults' => array(
								'controller' => 'StudioWebApi',
								'action'	 => 'studioStartDebugMode',
								'versions'	 => array('1.3')
						),
				),
		),
		'studioStopDebugMode' => array(
				'type'	=> 'Zend\Mvc\Router\Http\Literal',
				'options' => array(
						'route'	=> '/Api/studioStopDebugMode',
						'defaults' => array(
								'controller' => 'StudioWebApi',
								'action'	 => 'studioStopDebugMode',
								'versions'	 => array('1.3')
						),
				),
		),
		'studioIsDebugModeEnabled' => array(
				'type'	=> 'Zend\Mvc\Router\Http\Literal',
				'options' => array(
						'route'	=> '/Api/studioIsDebugModeEnabled',
						'defaults' => array(
								'controller' => 'StudioWebApi',
								'action'	 => 'studioIsDebugModeEnabled',
								'versions'	 => array('1.3')
						),
				),
		),			
		
	),		
);
