<?php

namespace StudioIntegration;

use Zend\Config\Config;

class Mapper {
	
	/**
	 * @var Config
	 */
	private $moduleConfiguration;
	
	public function getConfiguration() {
		$configuration = Configuration::getInstance();
		$configuration->setConfiguration($this->config('studioHost'), $this->config('studioPort'), $this->config('studioUseSsl'));
		$configuration->setAutoDetect($this->config('studioAutoDetection'));
		$configuration->setBrowserDetect($this->config('studioAutoDetectionEnabled'));
		return $configuration;
	}
	
	/**
	 * @param string $param
	 * @return array/string $moduleConfiguration
	 */
	public function config($param = null) {
		if (is_null($param)) {
			return $this->moduleConfiguration;
		}
		if (isset($this->moduleConfiguration[$param])) {
			return $this->moduleConfiguration[$param];
		} else {
			return '';
		}
	}

	/**
	 * @param array $moduleConfiguration
	 * @return Mapper
	 */
	public function setModuleConfiguration($moduleConfiguration) {
		$this->moduleConfiguration = $moduleConfiguration;
		return $this;
	}

}

