<?php

namespace ZendServer\Authentication\Adapter;

use Zend\Crypt\Hash;

use ZendServer\Log\Log;

use Zend\Authentication\Adapter\AdapterInterface;

use Users\Identity;

use Zend\Authentication\Adapter\DbTable as baseDbTable;

class DbTable extends baseDbTable {
	
	public function setCredential($credential) {
		return parent::setCredential(Hash::compute('sha256', $credential));
	}
	
	/* (non-PHPdoc)
	 * @see \Zend\Authentication\Adapter\DbTable::authenticate()
	 */
	public function authenticate() {
		
		$result = parent::authenticate();
		$identityRow = $this->getResultRowObject(array('NAME', 'ROLE'));
		
		$identity = $result->getIdentity(); /* @var $identity Identity */
		if ($result->isValid()) {
			$identity->setIdentity($identityRow->NAME);
			$identity->setRole($identityRow->ROLE);
			$identity->setUsername($identityRow->NAME);
		}
		
		return $result;
	}
	
	/* (non-PHPdoc)
	 * @see \Zend\Authentication\Adapter\DbTable::_authenticateSetup()
	 */
	protected function _authenticateSetup() {
	 	parent::_authenticateSetup();
	 	/// setup an empty identity object instead of the dead string identity
	 	$this->authenticateResultInfo['identity'] = new Identity($this->authenticateResultInfo['identity']);
	}

}
