<?php
namespace ZendServer\Serializer\Adapter;

use Zend\Serializer\Adapter\PhpSerialize;

class SafePhpSerialize extends PhpSerialize {

	public function unserialize($serialized, array $opts = array()) {
		// Set a temporary new unserialize callback function
		$previousUnserializeCallback = ini_get('unserialize_callback_func');
		ini_set('unserialize_callback_func', '\ZendServer\Serializer\Adapter\SafePhpSerialize::safePhpUnserialize');
		
		// Silent errors due to Zend_Loader autoloads and possible warning during unserialization of objects
		$unserializedData = parent::unserialize($serialized, $opts);

		// Set the previous unserialize callback
		ini_set('unserialize_callback_func', $previousUnserializeCallback);
		
		// If the return value of unserialize is flase, we have to check if the unserialize failed or tha value was really false
		if ($serialized == 'b:0;') {
			$unserializedData = false;
		}

		return $unserializedData;
	}

	public static function safePhpUnserialize($className) {
		if (! preg_match('|^\w*$|', $className)) {
			throw new \ZendServer\Exception('Invalid class name in serialized data');
		}
		eval("class $className {}");
	}

}

