<?php
namespace ZendServer;

use ZendServer\Edition,
	ZendServer\Exception;

class System {
	
	private $serverData;
	
	public function getZendServerVersion() {
		try {
			$version =  \Application\Module::config('package', 'version');
		} catch (Exception $e) {
			$version = _t('Unknown');
		}
		
		return $version;
	}
	
	public function getPHPVersion() {
		$serverData = $this->getServerData();
	
		return $serverData['phpversion'];
	}	
	
	public function getZendFramework1Version() {
		$serverData = $this->getServerData();
		
		return $serverData['zfversion'];
	}

	public function getZendFramework2Version() {
		$serverData = $this->getServerData();
	
		return $serverData['zf2version'];
	}
		
	private function getServerData() {
		if ($this->serverData) return $this->serverData;
		
		$edition = new Edition();
		$nodeId = $edition->getServerId();
		return $this->serverData = \Application\Module::serviceManager()->get('Configuration\MapperReplies')->getServerInfoWithRetry($nodeId);
	}
}
