<?php

namespace ZendServer\Serializer\Adapter;
use ZendServer\PHPUnit\TestCase;

use Zend\Log\Writer\Mock;
use Zend\Log\Logger;
use ZendServer\Log\Log;
require_once 'tests/bootstrap.php';

class SafePhpSerializeTest extends TestCase
{
	public function testFunctionDataWithObjects() {
                eval('class existClass { public $b = 2; protected $c = 3; private $d = 4; }');
                $obj = new \existClass();

		$safePhpSerialize = new \ZendServer\Serializer\Adapter\SafePhpSerialize();

                $data = array(
                        'O:13:"notExistClass":1:{s:1:"a";i:1;}',
                        serialize(false),
                        serialize(0),
                        serialize(null),
                        serialize(array(1,null,false,0,'x'=>array(3=>true, 'x'=>'x'))),
                        serialize($obj)
                );




	        // No way to check that the reutrn value is the notExistsClass (cause it's not defined), need to convert it to string first
	        $result = $safePhpSerialize->unserialize($data[0]);
	        $this->assertEquals('notExistClass',get_class($result));
	        $this->assertEquals(1,$result->a);
	        $result = $safePhpSerialize->unserialize($data[1]);
	        $this->assertSame(false,                $result);
	        $result = $safePhpSerialize->unserialize($data[2]);
	        $this->assertSame(0,                    $result);
	        $result = $safePhpSerialize->unserialize($data[3]);
	        $this->assertSame(null,                 $result);
	        $result = $safePhpSerialize->unserialize($data[4]);
	        $this->assertSame(array(1,null,false,0,'x'=>array(3=>true, 'x'=>'x')),
                                                        $result);
	        $result = $safePhpSerialize->unserialize($data[5]);
	        $this->assertEquals($obj,               $result);
        }


	
}

