<?php
ini_set ( 'display_errors' , 0 );
/// Disable statistics
if(function_exists('zend_disable_statistics')){
    @zend_disable_statistics();
}

/// Disable Monitoring
if(function_exists('monitor_event_reporting')) {
    @monitor_event_reporting(0);
}

if ( function_exists('page_cache_disable_caching') )
    @page_cache_disable_caching();
    
/// Make sure we got a valid 'cache' GET parameter set
if(!isset($_GET["cache"])) {
    die();
}

/// Clean the cache represented by $type
/// $type can be:
/// 'datacache_shm'
/// 'datacache_disk'
/// 'optimizerplus'
/// 'pagecache'
function cleanCache($type) {
    if ( $type == 'datacache_shm' && function_exists('zend_shm_cache_clear')) {
        zend_shm_cache_clear();
        
    } else if ( $type == 'datacache_disk' && function_exists('zend_disk_cache_clear')) {
        zend_disk_cache_clear();
        
    } else if ( $type == 'optimizerplus' && function_exists('accelerator_reset')) {
        accelerator_reset();
        
    } else if ( $type == 'pagecache' && function_exists ('page_cache_remove_all_cached_contents') ) {
        page_cache_remove_all_cached_contents();
        
    } else if ( $type == 'pagecache_by_rule' && function_exists ('page_cache_remove_cached_contents_by_rule') ) {
        // make sure we got a 'rule' index defined
        if ( !isset($_GET['ruleName']) ) {
            return;
        }
		if ( isset($_GET['uri']) && $_GET['uri'] ) {
            page_cache_remove_cached_contents_by_uri($_GET['ruleName'], $_GET['uri']);
        } else {
			page_cache_remove_cached_contents_by_rule($_GET['ruleName']);
		}
        
    } else if ( $type == 'pagecache_by_rules_ids' && function_exists ('page_cache_remove_cached_contents_by_rules_ids') ) {
        page_cache_remove_cached_contents_by_rules_ids(explode(",", $_GET['rules']));
    }
}

/// Clean the cache
if ( isset($_GET["cache"]) ) {
    cleanCache( $_GET["cache"] );
}
