<?php

class Zwas_Api_SignatureGenerator {

	/**
	 * @var string
	 */
	private $date 		= '';
	
	/**
	 * @var string
	 */
	private $userAgent  = '';
	
	/**
	 * @var string
	 */
	private $host 		= '';
	
	/**
	 * @var string
	 */
	private $requestUri	= '';
	
	/**
	 * @return string
	 */
	public function getRequestUri() {
		return $this->requestUri;
	}

	/**
	 * @return string
	 */
	public function getDate() {
		return $this->date;
	}

	/**
	 * @return string
	 */
	public function getUserAgent() {
		return $this->userAgent;
	}

	/**
	 * @return string
	 */
	public function getHost() {
		return $this->host;
	}

	/**
	 * @param string $requestUri
	 * @return Zwas_Api_SignatureGenerator
	 */
	public function setRequestUri($requestUri) {
		$this->requestUri = $requestUri;
		return $this;
	}
	
	/**
	 * @param string $date
	 * @return Zwas_Api_SignatureGenerator
	 */
	public function setDate($date) {
		$this->date = $date;
		return $this;
	}

	/**
	 * @param string $userAgent
	 * @return Zwas_Api_SignatureGenerator
	 */
	public function setUserAgent($userAgent) {
		$this->userAgent = $userAgent;
		return $this;
	}

	/**
	 * @param string $host
	 * @return Zwas_Api_SignatureGenerator
	 */
	public function setHost($host) {
		$this->host = $host;
		return $this;
	}

	/**
	 * @param string $seed
	 * @return string
	 */
	public function generate($seed) {
		$concatString = $this->host . ':' . $this->requestUri . ':' . $this->userAgent . ':' . $this->date;
		return hash_hmac('sha256', $concatString, $seed);
	}
}

$api = new Zwas_Api_SignatureGenerator();
$api->setRequestUri($_GET['uri']);
$api->setDate($_GET['date']);
$api->setUserAgent($_GET['agent']);
$api->setHost($_GET['host']);

echo $api->generate($_GET['key']);


?>