<?php
ini_set ( 'display_errors' , 0 );
date_default_timezone_set('UTC');

/// Disable statistics
if(function_exists('zend_disable_statistics'))
{
    @zend_disable_statistics();
}

/// Disable Monitoring
if(function_exists('monitor_event_reporting'))
{
    @monitor_event_reporting(0);
}

if ( function_exists('page_cache_disable_caching') )
    @page_cache_disable_caching();
    
function getPhpInfo()
{
    ob_start();
    phpinfo();
    return ob_get_clean();
}

function getServerInfo()
{
    $zfVersion  = "Unknown";
    $zfVersion2 = "Unknown";
    $phpinfo    = getPhpInfo();
    $phpversion = PHP_VERSION;
    
    // Get the Zend Framework version
    $ZEND_SERVER_INSTALL_PATH = get_cfg_var('zend.install_dir');
    
    if ( $ZEND_SERVER_INSTALL_PATH ) {
        
        // mkpath is the user function that join the path with DIRECTORY_SEPARATOR
        $zfPath  = $ZEND_SERVER_INSTALL_PATH . DIRECTORY_SEPARATOR . 'share/ZendFramework';
        $zfPath2 = $ZEND_SERVER_INSTALL_PATH . DIRECTORY_SEPARATOR . 'share/ZendFramework2';
        $zfFile  = $zfPath . DIRECTORY_SEPARATOR . 'library/Zend/Version.php';
        $zfFile2 = $zfPath2 . DIRECTORY_SEPARATOR . 'library/Zend/Version/Version.php';
        
        if (file_exists($zfFile)) {
            include_once $zfFile;
            if (class_exists('Zend_Version', false)) {
                $zfVersion = Zend_Version::VERSION;
            }
        }
        
        if (file_exists($zfFile2)) {
            include_once $zfFile2;
            if (class_exists('Zend\Version\Version', false)) {
                $zfVersion2 = Zend\Version\Version::VERSION;
            }
        }
    }
    
    $info = array();
    $info['phpinfo']     = $phpinfo;
    $info['zfversion']   = $zfVersion;
    $info['zf2version']  = $zfVersion2;
    $info['phpversion']  = $phpversion;
    return json_encode($info);
}

// ----------- main ----------------
echo getServerInfo();
