<?php
ini_set ( 'display_errors' , 0 );

if(function_exists('zend_disable_statistics'))
{
    @zend_disable_statistics();
}

/// Disable Monitoring
if(function_exists('monitor_event_reporting'))
{
    @monitor_event_reporting(0);
}

if ( function_exists('page_cache_disable_caching') )
    @page_cache_disable_caching();

/**
 * Contains the information about an extension
 */
class ExtensionInfo
{
    public $name;
    public $version;

    function __construct($name, $version, $licensed = NULL) {
        $this->name = $name;
        $this->version = $version;
        if(!is_null($licensed)) {
            $this->licensed = $licensed;
        }
    }
}

/**
 * @brief return a JSON representaion of all loaded extesnion
 * @returns string JSON string
 */
function printLoadedExtensions()
{
    $result = array();
    $phpExtensions  = get_loaded_extensions();
    $zendExtensions = get_loaded_extensions(TRUE);
    
    if ( function_exists('zem_get_extensions_info')) {
        $zemExtensionsInfo = zem_get_extensions_info();
    }
    
    $allExtensions  = array_unique( array_merge($phpExtensions, $zendExtensions) );
    foreach($allExtensions as $extension) {
        if ( $extension == "apc" && ini_get('apc.shm_size') === FALSE ) {
            // Fake APC
            $extension = "APC Compatibility Layer";
        }
        
        $ver = phpversion($extension);
        if( !$ver ) {
            $ver = "null";
        }
        
        if ( function_exists( 'zem_get_extension_info_by_name' ) ) {
            $zem_extension_info = zem_get_extension_info_by_name($extension);
        }
        
        if( $zem_extension_info !== false ) {
            
            if ( $zem_extension_info['is_enabled']) {
                $result[] = new ExtensionInfo($extension, $ver, $zem_extension_info['is_licensed']);
            }
            
        } else {
            $result[] = new ExtensionInfo($extension, $ver, true);
        }
    }
    return $result;
}
echo json_encode(printLoadedExtensions());
