CREATE TABLE IF NOT EXISTS ZSD_MONITOR_RULE_TYPES (
	TYPE_ID VARCHAR(64) NOT NULL PRIMARY KEY,
	TYPE_NAME VARCHAR(128) NOT NULL
);

CREATE TABLE IF NOT EXISTS ZSD_MONITOR_RULES (
	RULE_ID INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
	RULE_TYPE_ID VARCHAR(128) NOT NULL,
	RULE_PARENT_ID INTEGER DEFAULT -1,
	APP_ID INTEGER NOT NULL DEFAULT -1,
	NAME VARCHAR(64) NOT NULL,
	ENABLED INTEGER NOT NULL DEFAULT 1,
	DESCRIPTION VARCHAR(256),
	URL TEXT,
	CREATOR INTEGER NOT NULL DEFAULT 0
);

CREATE TABLE IF NOT EXISTS ZSD_MONITOR_RULE_TRIGGERS (
	TRIGGER_ID INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
	RULE_ID INTEGER NOT NULL,
	SEVERITY INTEGER NOT NULL DEFAULT 1
);

CREATE TABLE IF NOT EXISTS ZSD_MONITOR_RULE_CONDITIONS (
    CONDITION_ID INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
    RULE_ID INTEGER NOT NULL,
    TRIGGER_ID INTEGER NOT NULL,
    OPERATION VARCHAR(32) NOT NULL,
    ATTRIBUTE VARCHAR(32) NOT NULL,
    OPERAND TEXT DEFAULT ""
);

CREATE TABLE IF NOT EXISTS ZSD_MONITOR_ACTIONS (
	ACTION_ID INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
	TRIGGER_ID INTEGER NOT NULL,
	ACTION_TYPE INTEGER NOT NULL,
	ACTION_URL TEXT,
	SEND_TO VARCHAR(256),
    TRACING_DURATION INTEGER NOT NULL DEFAULT 0
);

CREATE INDEX IF NOT EXISTS ZSD_MONITOR_RULES_IDX1 ON ZSD_MONITOR_RULES(APP_ID);
CREATE UNIQUE INDEX IF NOT EXISTS ZSD_MONITOR_RULE_TRIGGERS_IDX1 ON ZSD_MONITOR_RULE_TRIGGERS(RULE_ID, SEVERITY);