CREATE TABLE IF NOT EXISTS GUI_AVAILABLE_LOGS (
	ID INTEGER NOT NULL PRIMARY KEY AUTO_INCREMENT,
	NAME VARCHAR(32) NOT NULL,
	FILEPATH VARCHAR(512),
	DIRECTIVE VARCHAR(64),
	ENABLED TINYINT DEFAULT 1
) ENGINE=MyISAM;

CREATE TABLE IF NOT EXISTS GUI_USERS (
	ID INTEGER NOT NULL PRIMARY KEY AUTO_INCREMENT,
	NAME VARCHAR(128) NOT NULL,
	PASSWORD VARCHAR(512) NOT NULL,
	ROLE VARCHAR(64) NOT NULL
) ENGINE=MyISAM;

CREATE TABLE IF NOT EXISTS GUI_LDAP_GROUPS (
	ID INTEGER NOT NULL PRIMARY KEY AUTO_INCREMENT,
	NAME VARCHAR(128) NOT NULL,
	LDAP_GROUP VARCHAR(512) NOT NULL,
	LINK_TYPE INTEGER NOT NULL
) ENGINE=MyISAM;

CREATE TABLE IF NOT EXISTS GUI_WEBAPI_KEYS (
	ID INTEGER NOT NULL PRIMARY KEY AUTO_INCREMENT,
	NAME VARCHAR(128) NOT NULL,
	HASH VARCHAR(512) NOT NULL,
	USERNAME VARCHAR(128) NOT NULL,
	CREATION_TIME INTEGER NOT NULL
) ENGINE=MyISAM;

CREATE TABLE IF NOT EXISTS GUI_SNAPSHOTS (
	ID INTEGER NOT NULL PRIMARY KEY AUTO_INCREMENT,
	NAME VARCHAR(128) NOT NULL,
	TYPE INTEGER DEFAULT 0,
	DATA BLOB NOT NULL,
	CREATION_TIME TIMESTAMP DEFAULT CURRENT_TIMESTAMP
) ENGINE=MyISAM;

CREATE TABLE IF NOT EXISTS GUI_LIBRARY_UPDATES (
	ID INTEGER NOT NULL PRIMARY KEY AUTO_INCREMENT,
	NAME VARCHAR(128) NOT NULL,
	VERSION VARCHAR(128) NOT NULL,
	EXTRA_DATA VARCHAR(1024),
	CREATION_TIME TIMESTAMP DEFAULT CURRENT_TIMESTAMP
) ENGINE=MyISAM;


CREATE TABLE IF NOT EXISTS GUI_ACL_ROLES (role_id INTEGER NOT NULL PRIMARY KEY AUTO_INCREMENT, role_name VARCHAR(128), role_parent INTEGER) ENGINE=MyISAM;

CREATE TABLE IF NOT EXISTS GUI_ACL_RESOURCES (resource_id INTEGER NOT NULL PRIMARY KEY AUTO_INCREMENT, resource_name VARCHAR(256) NOT NULL) ENGINE=MyISAM;

CREATE TABLE IF NOT EXISTS GUI_ACL_PRIVILEGES (role_id INTEGER NOT NULL, resource_id INTEGER NOT NULL, allow VARCHAR(1024))  ENGINE=MyISAM;

CREATE TABLE IF NOT EXISTS GUI_FILTERS (id INTEGER PRIMARY KEY AUTO_INCREMENT ,filter_type VARCHAR(64) NOT NULL, name VARCHAR(64), data TEXT, custom INTEGER DEFAULT 0) ENGINE=MyISAM;

set session sql_mode='NO_BACKSLASH_ESCAPES';
INSERT IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('codetracing', '/app/zend-server-6-php-5.4/var/log/codetracing.log', NULL);
INSERT IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('datacache', '/app/zend-server-6-php-5.4/var/log/datacache.log', NULL);
INSERT IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('deployment', '/app/zend-server-6-php-5.4/var/log/deployment.log', NULL);
INSERT IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('jobqueue', '/app/zend-server-6-php-5.4/var/log/jobqueue.log', NULL);
INSERT IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('jqd', '/app/zend-server-6-php-5.4/var/log/jqd.log', NULL);
INSERT IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('monitor', '/app/zend-server-6-php-5.4/var/log/monitor.log',NULL);
INSERT IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('monitor_node', '/app/zend-server-6-php-5.4/var/log/monitor_node.log', NULL);
INSERT IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('monitor_ui', '/app/zend-server-6-php-5.4/var/log/monitor_ui.log', NULL);
INSERT IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('pagecache', '/app/zend-server-6-php-5.4/var/log/pagecache.log', NULL);
INSERT IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('php', NULL,'error_log');
INSERT IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('sc', '/app/zend-server-6-php-5.4/var/log/sc.log', NULL);
INSERT IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('scd', '/app/zend-server-6-php-5.4/var/log/scd.log', NULL);
INSERT IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('statistics', '/app/zend-server-6-php-5.4/var/log/statistics.log', NULL);
INSERT IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('utils', '/app/zend-server-6-php-5.4/var/log/utils.log', NULL);
INSERT IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('zdd', '/app/zend-server-6-php-5.4/var/log/zdd.log', NULL);
INSERT IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('zem', '/app/zend-server-6-php-5.4/var/log/zem.log', NULL);
INSERT IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('zsd', '/app/zend-server-6-php-5.4/var/log/zsd.log', NULL);
INSERT IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('access', '/app/zend-server-6-php-5.4/var/log/access.log', NULL);
INSERT IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('error', '/app/zend-server-6-php-5.4/var/log/error.log', NULL);
INSERT IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('zend_server_ui', '/app/zend-server-6-php-5.4/gui/lighttpd/logs/zend_server_ui.log', NULL);
INSERT IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('zs-error', '/app/zend-server-6-php-5.4/gui/lighttpd/logs/php.log', NULL);
INSERT IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('zs_create_databases', '/app/zend-server-6-php-5.4/var/log/zs_create_databases.log', NULL);
set session sql_mode='';

REPLACE into schema_properties (property, property_value) values('gui_schema_version', '1.1.2');


INSERT IGNORE into GUI_WEBAPI_KEYS (NAME, HASH, USERNAME, CREATION_TIME) values('zend-zsd', LOWER(MD5(RAND())), 'System Key', '1292428752');
INSERT IGNORE INTO GUI_FILTERS VALUES(1,'issue','All Issues','{}',0);
INSERT IGNORE INTO GUI_FILTERS VALUES(2,'issue','Performance Issues','{"eventTypes":["function-slow-exec","request-slow-exec"]}',0);
INSERT IGNORE INTO GUI_FILTERS VALUES(3,'issue','Errors Issues','{"eventTypes":["function-error","zend-error","java-exception","jq-job-exec-error","tracer-write-file-fail","jq-job-logical-failure","custom"]}',0);
INSERT IGNORE INTO GUI_FILTERS VALUES(4,'issue','Resources Issues','{"eventTypes":["request-large-mem-usage","request-relative-large-out-size","jq-job-exec-delay"]}',0);
INSERT IGNORE INTO GUI_FILTERS VALUES(5,'job','All Jobs','{}',0);
INSERT IGNORE INTO GUI_FILTERS VALUES(6,'job','Failed Jobs','{"status":["Failed","Timeout"]}',0);
INSERT IGNORE INTO GUI_FILTERS VALUES(7,'job','Successful Jobs','{"status":["Completed"]}',0);
INSERT IGNORE INTO GUI_FILTERS VALUES(8,'audit','All Audit Entries','{}',0);

CREATE UNIQUE INDEX FILTERNAME_IDX1 ON GUI_FILTERS(name, filter_type);

CREATE UNIQUE INDEX unique_logs on GUI_AVAILABLE_LOGS (NAME);

CREATE UNIQUE INDEX USERS_IDX1 ON GUI_USERS(NAME);
CREATE UNIQUE INDEX SNAPSHOTS_IDX1 ON GUI_SNAPSHOTS(NAME);
CREATE UNIQUE INDEX WEBAPI_KEYS_IDX1 ON GUI_WEBAPI_KEYS(NAME);
CREATE UNIQUE INDEX LIBRARY_UPDATES_IDX1 ON GUI_LIBRARY_UPDATES(NAME);
