CREATE TABLE IF NOT EXISTS GUI_AVAILABLE_LOGS (
	ID INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
	NAME VARCHAR NOT NULL,
	FILEPATH VARCHAR,
	DIRECTIVE VARCHAR,
	ENABLED INTEGER DEFAULT 1
);

CREATE TABLE IF NOT EXISTS GUI_USERS (
	ID INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
	NAME VARCHAR NOT NULL,
	PASSWORD VARCHAR NOT NULL,
	ROLE VARCHAR NOT NULL
);

CREATE TABLE IF NOT EXISTS GUI_LDAP_GROUPS (
	ID INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
	NAME VARCHAR NOT NULL,
	LDAP_GROUP VARCHAR NOT NULL,
	LINK_TYPE INTEGER NOT NULL
);

CREATE TABLE IF NOT EXISTS GUI_WEBAPI_KEYS (
	ID INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
	NAME VARCHAR NOT NULL,
	HASH VARCHAR NOT NULL,
	USERNAME VARCHAR NOT NULL,
	CREATION_TIME INTEGER NOT NULL
);

CREATE TABLE IF NOT EXISTS GUI_METADATA (
	ID INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
	NAME VARCHAR NOT NULL,
	DATA VARCHAR NOT NULL,
	CDATE INTEGER DEFAULT CURRENT_TIMESTAMP NOT NULL
);

CREATE TABLE IF NOT EXISTS GUI_SNAPSHOTS (
	ID INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
	NAME VARCHAR NOT NULL,
	TYPE INTEGER DEFAULT 0,
	DATA BLOB NOT NULL,
	CREATION_TIME INTEGER DEFAULT CURRENT_TIMESTAMP NOT NULL
);

CREATE TABLE IF NOT EXISTS GUI_LIBRARY_UPDATES (
	ID INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
	NAME VARCHAR NOT NULL,
	VERSION VARCHAR NOT NULL,
	EXTRA_DATA VARCHAR(1024),
	CREATION_TIME INTEGER DEFAULT CURRENT_TIMESTAMP NOT NULL
);

CREATE TABLE IF NOT EXISTS GUI_FILTERS (id INTEGER PRIMARY KEY AUTOINCREMENT ,filter_type VARCHAR NOT NULL, name VARCHAR, data TEXT, custom INTEGER DEFAULT 0);

CREATE TABLE IF NOT EXISTS GUI_ACL_ROLES (role_id INTEGER PRIMARY KEY  AUTOINCREMENT  NOT NULL , role_name VARCHAR, role_parent INTEGER);

CREATE TABLE IF NOT EXISTS GUI_ACL_RESOURCES (resource_id INTEGER PRIMARY KEY  AUTOINCREMENT  NOT NULL , resource_name VARCHAR NOT NULL );

CREATE TABLE IF NOT EXISTS GUI_ACL_PRIVILEGES (role_id INTEGER NOT NULL , resource_id INTEGER NOT NULL , allow VARCHAR);


INSERT OR IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('codetracing', '/app/zend-server-6-php-5.4/var/log/codetracing.log', NULL);
INSERT OR IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('datacache', '/app/zend-server-6-php-5.4/var/log/datacache.log', NULL);
INSERT OR IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('deployment', '/app/zend-server-6-php-5.4/var/log/deployment.log', NULL);
INSERT OR IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('jobqueue', '/app/zend-server-6-php-5.4/var/log/jobqueue.log', NULL);
INSERT OR IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('jqd', '/app/zend-server-6-php-5.4/var/log/jqd.log', NULL);
INSERT OR IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('monitor', '/app/zend-server-6-php-5.4/var/log/monitor.log',NULL);
INSERT OR IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('monitor_node', '/app/zend-server-6-php-5.4/var/log/monitor_node.log', NULL);
INSERT OR IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('monitor_ui', '/app/zend-server-6-php-5.4/var/log/monitor_ui.log', NULL);
INSERT OR IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('pagecache', '/app/zend-server-6-php-5.4/var/log/pagecache.log', NULL);
INSERT OR IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('php', NULL,'error_log');
INSERT OR IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('sc', '/app/zend-server-6-php-5.4/var/log/sc.log', NULL);
INSERT OR IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('scd', '/app/zend-server-6-php-5.4/var/log/scd.log', NULL);
INSERT OR IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('statistics', '/app/zend-server-6-php-5.4/var/log/statistics.log', NULL);
INSERT OR IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('utils', '/app/zend-server-6-php-5.4/var/log/utils.log', NULL);
INSERT OR IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('zdd', '/app/zend-server-6-php-5.4/var/log/zdd.log', NULL);
INSERT OR IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('zem', '/app/zend-server-6-php-5.4/var/log/zem.log', NULL);
INSERT OR IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('zsd', '/app/zend-server-6-php-5.4/var/log/zsd.log', NULL);
INSERT OR IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('access', '/app/zend-server-6-php-5.4/var/log/access.log', NULL);
INSERT OR IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('error', '/app/zend-server-6-php-5.4/var/log/error.log', NULL);
INSERT OR IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('zend_server_ui', '/app/zend-server-6-php-5.4/gui/lighttpd/logs/zend_server_ui.log', NULL);
INSERT OR IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('zs-error', '/app/zend-server-6-php-5.4/gui/lighttpd/logs/php.log', NULL);
INSERT OR IGNORE INTO GUI_AVAILABLE_LOGS (NAME, FILEPATH, DIRECTIVE) VALUES ('zs_create_databases', '/app/zend-server-6-php-5.4/var/log/zs_create_databases.log', NULL);

INSERT OR REPLACE into GUI_METADATA (NAME, DATA) values('gui_schema_version', '1.1.2');

INSERT OR IGNORE into GUI_WEBAPI_KEYS (NAME, HASH, USERNAME, CREATION_TIME) values('zend-zsd', LOWER(HEX(RANDOM())), 'System Key', '1292428752');

INSERT OR IGNORE INTO GUI_FILTERS VALUES(1,'issue','All Issues','{}',0);
INSERT OR IGNORE INTO GUI_FILTERS VALUES(2,'issue','Performance Issues','{"eventTypes":["function-slow-exec","request-slow-exec"]}',0);
INSERT OR IGNORE INTO GUI_FILTERS VALUES(3,'issue','Errors Issues','{"eventTypes":["function-error","zend-error","java-exception","jq-job-exec-error","tracer-write-file-fail","jq-job-logical-failure","custom"]}',0);
INSERT OR IGNORE INTO GUI_FILTERS VALUES(4,'issue','Resources Issues','{"eventTypes":["request-large-mem-usage","request-relative-large-out-size","jq-job-exec-delay"]}',0);
INSERT OR IGNORE INTO GUI_FILTERS VALUES(5,'job','All Jobs','{}',0);
INSERT OR IGNORE INTO GUI_FILTERS VALUES(6,'job','Failed Jobs','{"status":["Failed","Timeout"]}',0);
INSERT OR IGNORE INTO GUI_FILTERS VALUES(7,'job','Successful Jobs','{"status":["Completed"]}',0);
INSERT OR IGNORE INTO GUI_FILTERS VALUES(8,'audit','All Audit Entries','{}',0);

CREATE UNIQUE INDEX IF NOT EXISTS USERS_IDX1 ON GUI_USERS(NAME);
CREATE UNIQUE INDEX IF NOT EXISTS SNAPSHOTS_IDX1 ON GUI_SNAPSHOTS(NAME);
CREATE UNIQUE INDEX IF NOT EXISTS WEBAPI_KEYS_IDX1 ON GUI_WEBAPI_KEYS(NAME);
CREATE UNIQUE INDEX IF NOT EXISTS METADATA_IDX1 ON GUI_METADATA(NAME);
CREATE UNIQUE INDEX IF NOT EXISTS LIBRARY_UPDATES_IDX1 ON GUI_LIBRARY_UPDATES(NAME);
CREATE UNIQUE INDEX IF NOT EXISTS unique_logs on GUI_AVAILABLE_LOGS (NAME);
CREATE UNIQUE INDEX IF NOT EXISTS FILTERNAME_IDX1 ON GUI_FILTERS(name, filter_type);

