CREATE TABLE IF NOT EXISTS ZSD_NOTIFICATIONS (
    ID INTEGER NOT NULL PRIMARY KEY AUTO_INCREMENT,
    TYPE INTEGER,
    SEVERITY INTEGER,
    CREATION_TIME INTEGER,
    REPEATS INTEGER NOT NULL DEFAULT 0,
    SHOW_AT INTEGER NOT NULL,
    NOTIFIED INTEGER NOT NULL DEFAULT 0,
    EXTRA_DATA VARCHAR(1024),
    NODE_ID INTEGER NOT NULL DEFAULT -1
) Engine=MyISAM;

CREATE TABLE IF NOT EXISTS ZSD_NOTIFICATIONS_ACTIONS (
    TYPE INTEGER NOT NULL PRIMARY KEY,
    NAME VARCHAR(64),
    EMAIL VARCHAR(256),
    CUSTOM_ACTION VARCHAR(1024)
) Engine=MyISAM;

CREATE UNIQUE INDEX ZSD_NOTIFICATIONS_IDX1 ON ZSD_NOTIFICATIONS(TYPE);
CREATE INDEX ZSD_NOTIFICATIONS_IDX2 ON ZSD_NOTIFICATIONS(NODE_ID);

CREATE TABLE IF NOT EXISTS ZSD_MESSAGES_FILTERS (
    FILTER_ID  INTEGER NOT NULL PRIMARY KEY AUTO_INCREMENT,
    FILTER_TYPE INTEGER NOT NULL,
    SHOW_AT INTEGER NOT NULL
) Engine=MyISAM;

REPLACE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (0,  'serverOffline');
REPLACE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (1,  'restartRequired');
REPLACE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (2,  'daemonOffline');
REPLACE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (3,  'phpExtDirectiveMismatch');
REPLACE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (4,  'phpExtNotLoaded');
REPLACE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (5,  'phpExtNotInstalled');
REPLACE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (6,  'zendExtDirectiveMismatch');
REPLACE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (7,  'zendExtNotLoaded');
REPLACE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (8,  'zendExtNotInstalled');
REPLACE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (9,  'deploymentFailure');
REPLACE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (10, 'deploymentUpdateFailure');
REPLACE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (11, 'deploymentRedeployFailure');
REPLACE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (12, 'deploymentHealthcheckFailure');
REPLACE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (13, 'deploymentRemoveFailure');
REPLACE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (14, 'deploymentRollbackFailure');
REPLACE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (15, 'deploymentDefineAppFailure');
REPLACE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (16, 'serverAddError');
REPLACE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (17, 'serverRemoveError');
REPLACE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (18, 'serverEnableError');
REPLACE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (19, 'serverDisableError');
REPLACE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (20, 'serverForceRemoveError');
REPLACE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (21, 'jobqueueHighConcurrency');
REPLACE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (22, 'serverRestarting');
REPLACE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (23, 'sessionClusteringWrongHandler');
REPLACE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (26, 'invalidLicense');
REPLACE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (27, 'licenseAboutToExpire');
REPLACE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (28, 'webserverNotResponding');
REPLACE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (29, 'maxServersInCluster');
REPLACE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (30, 'licenseAboutToExpire45');
REPLACE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (31, 'licenseAboutToExpire15');
REPLACE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (32, 'databaseConnectionRestored');
REPLACE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (33, 'sessionClusteringStdbyMode');
REPLACE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (34, 'zendServerDaemonOffline');
REPLACE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (35, 'sessionClusteringErrorMode');
REPLACE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (36, 'mailSettingsError');
REPLACE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (37, 'sessionClusteringShutdownError');
REPLACE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (500, 'libraryUpdateAvailable');

CREATE UNIQUE INDEX FILTERS1 ON ZSD_MESSAGES_FILTERS(FILTER_TYPE);
CREATE UNIQUE INDEX FILTERS2 ON ZSD_MESSAGES_FILTERS(SHOW_AT);
