<?php
	
	function Zend_Monitor_Resolve_Components() {
		$res = array();
		
		global $serviceManager;
		
		if (function_exists("Mage:app")) {
			$res['type'] = "Magento";
			if (Mage::app() && Mage::app()->getFrontController() && Mage::app()->getFrontController()->getRequest()) {
				$res = array_merge($res, array(
					"module" => Mage::app()->getFrontController()->getRequest()->getModuleName(), 
					"controller" => Mage::app()->getFrontController()->getRequest()->getControllerName(),
					"action" => Mage::app()->getFrontController()->getRequest()->getActionName(),
					"params" => Mage::app()->getFrontController()->getRequest()->getParams()
					));
				}
		} else if (class_exists('\Zend\Version', false) && $serviceManager && ($serviceManager instanceof \Zend\ServiceManager\ServiceManager) ) {			
			$res = array();
			/* @var $theApp \Zend\Mvc\Application */
			$theApp = $serviceManager->get("Application");
			/* @var $theEvent \Zend\Mvc\MvcEvent */
			$theEvent = $theApp->getMvcEvent();
			
			$res['type'] = "Zend Framework 2";
			$res = $theEvent->getRouteMatch()->getParams();
			foreach ($res as $key => $value) {
				if (is_array($value)) {
					$str = "";
					foreach ($value as $arrKey => $arrVal) {
						if ($str) {
							$str .= "&";
						}
						$str .= $arrKey . "=" . $arrVal;
					}					
					$res[$key] = $str;
				}
			}
			
		} else if (function_exists("Zend_Controller_Front::getInstance")) {
			$res['type'] = "Zend Framework";
			if (Zend_Controller_Front::getInstance() && Zend_Controller_Front::getInstance()->getRequest()) {
				$res =  array_merge($res, array(
				"module" => Zend_Controller_Front::getInstance()->getRequest()->getModuleName(), 
				"controller" => Zend_Controller_Front::getInstance()->getRequest()->getControllerName(),
				"action" => Zend_Controller_Front::getInstance()->getRequest()->getActionName(),
				"params" => Zend_Controller_Front::getInstance()->getRequest()->getParams()
				));
			}
		} else if (defined('WPLANG')) {
			$res['type'] = "Wordpress";
			global $wp_filter, $wp_actions, $merged_filters, $wp_current_filter;
			
			$res =  array_merge($res, $merged_filters);
			
		} else if (class_exists('DrupalDefaultEntityController', false)) {
			$res['type'] = "Drupal";
			$res =  array_merge($res, array( "arguments" => explode("/", $_GET['q'])));
		} else if (isset($_REQUEST['module']) && isset($_REQUEST['action'])) {
			$res['type'] = "SugarCRM";
			$res = array_merge($res, array (
				"module" => $_REQUEST['module'],
				"action" => $_REQUEST['action']
			));
		
		} else {
			$res['type'] = "Unknown";
		}
		
		
		return $res;
	}
	
