<?php
class ZSDbSettings {
	
	
	private $dbType, $dbHost, $dbPort, $dbName, $dbUser, $dbPassword;
	
	
	public static function fromIni($path) {
		
		if (!file_exists($path)) {
			return null;
		}
		
		$settings = new ZSDbSettings;
		
		$ini = parse_ini_file($path);

		foreach ($ini as $key => $value) {
			if (strstr($key, ".host_name")) {
				$settings->dbHost = $value;
			} else if (strstr($key, ".port")) {
				$settings->dbPort = $value;
			} else if (strstr($key, ".user")) {
				$settings->dbUser = $value;
			} else if (strstr($key, ".password")) {
				$settings->dbPassword = $value;
			} else if (strstr($key, ".name")) {
				$settings->dbName = $value;
			} else if (strstr($key, ".database.type")) {
				$settings->dbType = $value;
			} else {
				//error ("Unknown key in INI $path: " . $key);	
			}			
		}
		
		return $settings;
		
	}
	
	/**
	 * @return the $dbType
	 */
	public function getDbType() {
		return $this->dbType;
	}

	/**
	 * @return the $dbHost
	 */
	public function getDbHost() {
		return $this->dbHost;
	}

	/**
	 * @return the $dbPort
	 */
	public function getDbPort() {
		return $this->dbPort;
	}

	/**
	 * @return the $dbName
	 */
	public function getDbName() {
		return $this->dbName;
	}

	/**
	 * @return the $dbUser
	 */
	public function getDbUser() {
		return $this->dbUser;
	}

	/**
	 * @return the $dbPassword
	 */
	public function getDbPassword() {
		return $this->dbPassword;
	}

	/**
	 * @param field_type $dbType
	 */
	public function setDbType($dbType) {
		$this->dbType = $dbType;
	}

	/**
	 * @param field_type $dbHost
	 */
	public function setDbHost($dbHost) {
		$this->dbHost = $dbHost;
	}

	/**
	 * @param field_type $dbPort
	 */
	public function setDbPort($dbPort) {
		$this->dbPort = $dbPort;
	}

	/**
	 * @param field_type $dbName
	 */
	public function setDbName($dbName) {
		$this->dbName = $dbName;
	}

	/**
	 * @param field_type $dbUser
	 */
	public function setDbUser($dbUser) {
		$this->dbUser = $dbUser;
	}

	/**
	 * @param field_type $dbPassword
	 */
	public function setDbPassword($dbPassword) {
		$this->dbPassword = $dbPassword;
	}
	
	public function isMysql() {
		return (strstr(strtolower($this->dbType), "mysql") !== false);
	}
	
	
}

?>