<?php
/**********************************************************************
*                                                                     *
*  php-cgi zs_merge_ini.php from=old_dir to=new_dir	[type=minor/major]*                             	 *
*  merge ini from old path to new path and save it with the same name *
*                                                                     *
**********************************************************************/

if( function_exists("date_default_timezone_set") && function_exists("date_default_timezone_get")) {
	date_default_timezone_set(@date_default_timezone_get());
}
global $logFile;
$logFile = NULL;
$backupName= "-clean_6.1.0";
$oldDir = $_GET['from'];
$newDir = $_GET['to'];
// set type if not defined as major
if (!(isset($_GET['type']))){
		$type = "major";
	}else{
	$type = $_GET['type'];
	}
if (strpos ( $oldDir, ".ini" ) && strpos( $newDir, ".ini" )){ //compare of files
	message("***********************************");
	message("Working on one file on " . $type . " upgrade");
	message("***********************************");
	if (file_exists ( $oldDir) &&  file_exists ( $newDir) ){
		if ($type == "major"){
					message("merging " . $oldDir ." with " . $newDir);
					mergeIniFile ( $oldDir, $newDir, $newDir , $backupName);
		}else{
					message("overwriting " . $oldDir ." with " . $newDir);
					overwritingIniFile ( $oldDir, $newDir);
		}
	}else{
		if (!(file_exists ( $oldDir))){
			message("The from file " . $oldDir ." does not exist");
			}
		if (!(file_exists ( $newDir))){
			message("The to file " . $newDir ." does not exist");
				// copying file from old to new if not exist
				if ($type == "minor"){
					if (copy($oldDir, $newDir)){
						chmod($newDir, fileperms($oldDir));
						message("Copy from " . $oldDir ." to " . $newDir ." and fixing permissions");
					}else{
						message("ERROR: Failed coping from " . $oldDir ." to " . $newDir ." and fixing permissions");
					}
				}
			
		}
	}
	
	
}else{  //compare of directoris

	// get the files list in directory
	$oldFiles = scandir ( $oldDir );
	$newFiles = scandir ( $newDir );

	$oldFiles = createIniList ( $oldFiles );
	$newFiles = createIniList ( $newFiles );
	
	$allFiles = array_merge( $newFiles, $oldFiles );
	$allFiles = array_unique( $allFiles );

	message("***********************************");
	message("Working on folders " . $oldDir ." with " . $newDir . " on " .  $type . " upgrade");
	foreach ( $allFiles as $filename ) {
		
		$oldIni = $oldDir . DIRECTORY_SEPARATOR . $filename;
		$newIni = $newDir . DIRECTORY_SEPARATOR . $filename;
		$outputIni = $newDir . DIRECTORY_SEPARATOR . $filename;
		//ignore files that are not watchdog or mime types inis
		if (!(strpos ( $oldIni, "watchdog" )) && !(strpos ( $oldIni, "zend_mime_types" ))) {
			if (file_exists ( $oldIni.".rpmsave")){
				if (strpos ( $oldIni, "5.6.0" ) ){
					$oldIni = $oldIni.".rpmsave";
				} elseif (strpos ( $oldIni, "php.ini" )) {
					$oldIni = $oldIni.".rpmsave";
				}
			}
			message("***********************************");
			if (file_exists ( $oldIni) &&  file_exists ( $newIni) ){
				
				if ($type == "major"){
					message("merging " . $oldIni ." with " . $newIni);
					mergeIniFile ( $oldIni, $newIni, $outputIni , $backupName);
					}else{
					// Overwriting function call
						if (strpos ( $newIni, "packaging" )){ // if file is packaging.ini
							$file_contents = file_get_contents( $newIni);
							$file_contents = preg_replace('/[ ]+/', '',$file_contents);
							$file_contents = str_replace("zend_gui.zs_upgrade=0","zend_gui.zs_upgrade=1",$file_contents);                       
							file_put_contents($newIni,$file_contents);
							message("Updated zend_gui.zs_upgrade in " . $newIni ." to 1");
						}else{
							message("overwriting " . $newIni ." with " . $oldIni);
							overwritingIniFile ( $oldIni, $newIni);
						}
					}
			}else{
				if (!(file_exists ( $oldIni))){
					message("The \"from\" file " . $oldIni ." does not exist");
					if (strpos ( $newIni, "packaging" )){
						$file_contents = file_get_contents( $newIni);
						$file_contents = preg_replace('/[ ]+/', '',$file_contents);
                        $file_contents = str_replace("zend_gui.zs_upgrade=0","zend_gui.zs_upgrade=1",$file_contents);                       
						file_put_contents($newIni,$file_contents);
						message("Updated zend_gui.zs_upgrade in " . $newIni ." to 1");
					}
					
				}
				if (!(file_exists ( $newIni))){
					message("The \"to\" file " . $newIni ." does not exist");
				}
			}
		}
	}
}
// --------------- FUNCTIONS -----------------
/**
 * overwrite new ini with old one
 * @param string $oldIni        	
 * @param string $newIni        	
 */
function overwritingIniFile($oldIni, $newIni) {

$current = file_get_contents($oldIni);
file_put_contents($newIni, $current);
message("contnts moved from  " . $oldIni ." to  " . $newIni);

}
// --------------- FUNCTIONS -----------------
/**
 * merge two ini files to one
 * @param string $oldIni        	
 * @param string $newIni        	
 * @param string $outputIni
 * @param string $backupName 
 */
function mergeIniFile($oldIni, $newIni, $outputIni , $backupName) {
	
	// exceptions for cfg files
	$cfgExceptions = array ();
	//exceptions for etc files
	$etcExceptions = array (
			"zend_deployment.log_verbosity_level" => "zend_deployment.daemon.log_verbosity_level",
			"zend_deployment.log_rotation_size" => "zend_deployment.daemon.log_rotation_size",
			"zend_monitor.log_verbosity" => "zend_monitor.daemon.log_verbosity",
			"zend_monitor.log_rotation_size" => "zend_monitor.daemon.log_rotation_size",
			"zend_jobqueue.log_verbosity_level" => "zend_jobqueue.daemon.log_verbosity_level",
			"zend_jobqueue.log_rotation_size" => "zend_jobqueue.daemon.log_rotation_size",
			"zend_sc.enable" => "zend_sc.daemon.enable",
			"zend_sc.log_verbosity_level" => "zend_sc.daemon.log_verbosity_level",
			"zend_sc.log_rotation_size" => "zend_sc.daemon.log_rotation_size" 
	);
	if (strpos ( $newIni, "cfg" ) || strpos ( $newIni, "conf.d" )) {
		$exceptions = $cfgExceptions;
	} else {
		$exceptions = $etcExceptions;
	}
	//these directives won't appear on merged ini
	$delete_exceptions = array (
			"zend_jobqueue.execution_queues",
			"zend_monitor.node_id",
			"zend_monitor.database.password",
			"zend_monitor.database.user",
			"zend_monitor.database.port",
			"zend_monitor.database.type",
			"zend_monitor.database.name",
			"zend_monitor.database.host_name",
			"zend_deployment.database.type",
			"zend_deployment.database.host",
			"zend_deployment.database.port",
			"zend_deployment.database.schema",
			"zend_deployment.database.user",
			"zend_deployment.database.password"
	);
	
	$set_to_one_exceptions = array (
			"zend_codetracing.enable",
			"zend_datacache.enable",
			"zend_monitor.enable",
			"zend_jobqueue.enable",
			"zend_loader.enable",
			"zend_optimizerplus.enable",
			"zend_pagecache.enable",
			"zend_gui.zs_upgrade",
	);
	// these directive are get overwritten by clean value
	$ignore_exceptions = array (
			"zend_gui.build",
			"zend_gui.version",
	);
	// get old ini as array - $arrLinesOfOldFile = old file as array
	$oldFile = fopen ( $oldIni, "rb" );
	while ( ! feof ( $oldFile ) ) {
		$arrLinesOfOldFile [] = fgets ( $oldFile );
	}
	fclose ( $oldFile );
	
	// get new ini as array - $arrLineOfNewFile = new file as array
	$newFile = fopen ( $newIni, "rb" );
	while ( ! feof ( $newFile ) ) {
		$arrLineOfNewFile [] = fgets ( $newFile );
	}
	fclose ( $newFile );
	// get diff array
	$arrMergedOldToNew = array ();
	$arrMergedNewToOld = array ();
	$seperatorArray = array ();
	$seperatorArray [] = "\n;******************************************************************\n;* Directives from old configuration that do not exist in current *\n;* installation are placed below (probably deprecated)            *\n;******************************************************************\n";
	$directiveMerged = false;
	// remove space between "=" and double spacing in line;
	$arrLineOfNewFile = preg_replace('/\s\s+/', ' ', $arrLineOfNewFile);
	$arrLinesOfOldFile = preg_replace('/\s\s+/', ' ', $arrLinesOfOldFile);
	$arrLineOfNewFile = str_replace ( " = ", "=", $arrLineOfNewFile );
	$arrLineOfNewFile = str_replace ( " =", "=", $arrLineOfNewFile );
	$arrLineOfNewFile = str_replace ( "= ", "=", $arrLineOfNewFile );
	$arrLinesOfOldFile = str_replace ( " = ", "=", $arrLinesOfOldFile );
	$arrLinesOfOldFile = str_replace ( " =", "=", $arrLinesOfOldFile );
	$arrLinesOfOldFile = str_replace ( "= ", "=", $arrLinesOfOldFile );
	//if arrays not identical then backup
	$result = array_diff($arrLinesOfOldFile, $arrLineOfNewFile);
	if(!(empty($result))){
		// leave a clean copy an machine with $backupName extension
		copy ( $newIni, $newIni . $backupName );
		message("backing up ". $newIni . " to " . $newIni . $backupName  );
	}
	//go over new.ini file
	foreach ( $arrLineOfNewFile as $line ) {
		$directiveMerged = false;
		$trimLine = trim ( $line );
		$firstChar = substr ( $trimLine, 0, 1 );
		if (strpos ( $trimLine, '=' ) !== false) {
			$directiveLineNew = explode ( "=", $trimLine, 2 );
				if (!(isset($directiveLineNew [1]))){
					$directiveLineNew [1] = "";
				}
		}
		// if commented on new.ini then copy to file
		if ($firstChar == ';') {
			$arrMergedOldToNew [] = $trimLine;
		} 		// if [ ] on new.ini then copy to file
		elseif ($firstChar == '[') {
			$arrMergedOldToNew [] = $trimLine;
		} 		// if empty line on new.ini then copy to file
		elseif ($firstChar == '') {
			$arrMergedOldToNew [] = $trimLine;
		} else {
			// scan old file directive
			foreach ( $arrLinesOfOldFile as $oldLine ) {
				$trimOldLine = trim ( $oldLine );
				if (strpos ( $trimOldLine, '=' ) !== false) {
					// split it only for two 
					$directiveLineOld = explode ( "=", $trimOldLine, 2 );
					// if same directives
					if ($directiveLineNew [0] == $directiveLineOld [0]) {
						// if  directive is "extension" get value from old
						if ($directiveLineNew [0] == "extension") {
							if (! (in_array ( $trimOldLine, $arrMergedOldToNew ))) {
								$arrMergedOldToNew [] = $trimOldLine;
							};
							//if  directive is "extension" and not exist in old get value from new
							if (! (in_array ( $trimLine, $arrMergedOldToNew ))) {
								
								$arrMergedOldToNew [] = $trimLine;
							}
							$directiveMerged = true;
						//ZSRV-9003  zend_monitor.event_tracing_mode  should never be equal to 1
						}elseif($directiveLineNew [0] == "zend_monitor.event_tracing_mode") {
							if ($directiveLineOld [1] == "1"){
								$arrMergedOldToNew [] = $directiveLineNew [0] . "=" . $directiveLineNew [1];
							}else{
								$arrMergedOldToNew [] = $directiveLineNew [0] . "=" . $directiveLineOld [1];	
							}
							$directiveMerged = true;
						}elseif(in_array ( $directiveLineNew [0], $set_to_one_exceptions )) { // if directive exist in arrey then set to 1
							$arrMergedOldToNew [] = $directiveLineNew [0] . "=1";
							$directiveMerged = true;
						}elseif($directiveLineNew [0] == "zend_codetracing.use_fast_timestamp") { // if merge is run then set zend_codetracing.use_fast_timestamp=0
							$arrMergedOldToNew [] = $directiveLineNew [0] . "=0";
							$directiveMerged = true;
						}elseif($directiveLineNew [0] == "zend_monitor.use_fast_timestamp") { // if merge is run then set zend_monitor.use_fast_timestamp=0
							$arrMergedOldToNew [] = $directiveLineNew [0] . "=0";
							$directiveMerged = true;
						}elseif(in_array ( $directiveLineNew [0], $ignore_exceptions )) { // if directive in ignore_exceptions array then use the the new value and not the old
							$arrMergedOldToNew [] = $directiveLineNew [0] . "=" . $directiveLineNew [1];
							$directiveMerged = true;
						}else {
							//directive exist in old and new get value from old
							$arrMergedOldToNew [] = $directiveLineNew [0] . "=" . $directiveLineOld [1];
							$directiveMerged = true;
						}
					} else {
						//directives not the same check for exceptions
						reset ( $exceptions );
						while ( current ( $exceptions ) ) {
							
							if (key ( $exceptions ) == $directiveLineOld [0] && (current ( $exceptions )) == $directiveLineNew [0]) {
								$arrMergedOldToNew [] = $directiveLineNew [0] . "=" . $directiveLineOld [1];
								$directiveMerged = true;
							}
							next ( $exceptions );
							
						}
					}
				}
			}
			// in case new directive not exist in old
			if ($directiveMerged == false) {
				$arrMergedOldToNew [] = $directiveLineNew [0] . "=" . $directiveLineNew [1];
			}
		}
	}
	
	$i = 0;
	//go over old.ini file
	foreach ( $arrLinesOfOldFile as $line ) {
		
		$trimLine = trim ( $line );
		$firstChar = substr ( $trimLine, 0, 1 );
		if (strpos ( $trimLine, '=' ) !== false) {
			$directiveNew_final_array = explode ( "=", $trimLine, 2 );
		}
		// if commented on old.ini then remove from array
		if ($firstChar == ';') {
			unset ( $arrLinesOfOldFile [$i] );
		} 		// if [ ] on old.ini then remove from array
		elseif ($firstChar == '[') {
			unset ( $arrLinesOfOldFile [$i] );
		} 		// if empty line on on old,ini then remove from array
		elseif ($firstChar == '') {
			unset ( $arrLinesOfOldFile [$i] );
		} else {
			// scan new.ini file directive
			foreach ( $arrLineOfNewFile as $newLine ) {
				$trimNewLine = trim ( $newLine );
				if (strpos ( $trimNewLine, '=' ) !== false) {
					$directiveLineNew = explode ( "=", $trimNewLine, 2 );
					$directiveLineOld = explode ( "=", $trimLine, 2 );
					// same directives then remove from array
					if ($directiveLineNew [0] == $directiveNew_final_array [0]) {
						unset ( $arrLinesOfOldFile [$i] );
					} else {
						//remove exceptions from old.ini
						reset ( $exceptions );
						while ( current ( $exceptions ) ) {
							if (key ( $exceptions ) == $directiveNew_final_array [0]) {
								unset ( $arrLinesOfOldFile [$i] );
							}
							next ( $exceptions );
						}
						reset ( $delete_exceptions );
						while ( current ( $delete_exceptions ) ) {
							if ( current ( $delete_exceptions ) == $directiveLineOld [0] ) {
								unset ( $arrLinesOfOldFile [$i] );
							}
							next ( $delete_exceptions );
							
						}
					}
				}
			}
		}
		$i ++;
	}
	// if you have lines in old.ini which are not in new one one the merge them
	if ( count( $arrLinesOfOldFile) == 0){
		$result = $arrMergedOldToNew;
	}else{
		$result = array_merge ( ( array ) $arrMergedOldToNew, ( array ) $seperatorArray, ( array ) $arrLinesOfOldFile );
	}
	
	//put arrey in file
	$str = implode ( PHP_EOL, $result );
	file_put_contents ( $outputIni, $str );
	message("Finished merging ". $outputIni  );
}
function createIniList($files) {
	$result = array ();
	foreach ( $files as $filename ) {
		$ext = substr ( $filename, strrpos ( $filename, '.' ) + 1 );
		if (strtolower ( $ext ) == 'ini') {
			$result [] = $filename;
		}
	}
	return $result;
}

	function logMsg($str) {
		global $logFile;
		if (!$logFile) {
			if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN') {
				$logPath = $_GET['zsDir'] . "/logs/zs_merge_ini.log" ;
			} else {
				$logPath = $_GET['zsDir'] . "/var/log/zs_merge_ini.log" ;
			}
			$logFile = @fopen($logPath, "a+");
			ini_set("log_errors", 1);
			ini_set("error_log", $logPath);
		}
		
		$str = "[" . date('c') . "] " . $str;
		@fwrite($logFile, $str . PHP_EOL);
	}
	
	function message($str) {
		global $verbosity;
		if ($verbosity > 0) {
			echo $str . PHP_EOL;		
		}		
		
		logMsg($str);
	}
