<?php

require_once dirname(__FILE__) . "/zs_component_upgrader.php";

class CodeTracingDBHandler extends ZSComponentUpgrader {
	
		
	protected function getSqliteDbName($version = "6.0.0") {
		if ($version == "5.6.0") {
			return "monitor_codetracing";
		} else {
			return "codetracing.db";
		}
	}
	
	protected function getMysqlSqlFilenames() {
		return array("mysql_create_monitor_db.sql");
	}
	
	protected function getSqliteSqlFilenames() {
		return array("create_monitor_tracing_db.sql");
	}
	
	protected function upgradeSqlite() {
		
		$upgradeFromVersion = $this->getUpgradeFromVersion();
		if (version_compare($upgradeFromVersion, "6.0.0", ">=")) {
			message("Keeping tracing db from $upgradeFromVersion");
			$this->copySqliteFromPreviousVersions();
		}
		
		if (file_exists($this->getSqliteDbPath())) {
			message("Database at " . $this->getSqliteDbPath() . " already exists");
			return;
		}
		
		if ($this->copySqliteFromPreviousVersions("6.0.0")){
			message("Using tracing db from version 6.0.0");
		} else {
			$this->createCleanSqliteDatabase();
		}	
	}
	
	protected function upgradeMysql() {
		
		$this->createCleanMysqlDatabase();
		
		$dbh6 = $this->getMySqlDbh("6.0.0");
		if ($dbh6) {
			message("Upgrade from 6.0.0 - doing nothing");
			return;
		}
	}
	
	public function upgrade() {
		$this->upgradeSqlite();
		
		if ($this->isClusterUpgrade()) {
			$this->upgradeMysql();
		}
	}	
}

?>