CREATE TABLE IF NOT EXISTS ZSD_NOTIFICATIONS (
    ID INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
    TYPE INTEGER,
    SEVERITY INTEGER,
    CREATION_TIME INTEGER,
    REPEATS INTEGER NOT NULL DEFAULT 0,
    SHOW_AT INTEGER NOT NULL,
    NOTIFIED INTEGER NOT NULL DEFAULT 0,
    EXTRA_DATA VARCHAR(1024),
    NODE_ID INTEGER NOT NULL DEFAULT -1
);

CREATE TABLE IF NOT EXISTS ZSD_NOTIFICATIONS_ACTIONS (
    TYPE INTEGER NOT NULL PRIMARY KEY,
    NAME VARCHAR,
    EMAIL VARCHAR,
    CUSTOM_ACTION VARCHAR
);

CREATE UNIQUE INDEX IF NOT EXISTS ZSD_NOTIFICATIONS_IDX1 ON ZSD_NOTIFICATIONS(TYPE);
CREATE INDEX IF NOT EXISTS ZSD_NOTIFICATIONS_IDX2 ON ZSD_NOTIFICATIONS(NODE_ID);

CREATE TABLE IF NOT EXISTS ZSD_MESSAGES_FILTERS (
    FILTER_ID  INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
    FILTER_TYPE INTEGER NOT NULL,
    SHOW_AT INTEGER NOT NULL
);

CREATE UNIQUE INDEX IF NOT EXISTS FILTERS1 ON ZSD_MESSAGES_FILTERS(FILTER_TYPE);
CREATE UNIQUE INDEX IF NOT EXISTS FILTERS2 ON ZSD_MESSAGES_FILTERS(SHOW_AT);

INSERT OR IGNORE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (0,  'serverOffline');
INSERT OR IGNORE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (1,  'restartRequired');
INSERT OR IGNORE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (2,  'daemonOffline');
INSERT OR IGNORE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (3,  'phpExtDirectiveMismatch');
INSERT OR IGNORE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (4,  'phpExtNotLoaded');
INSERT OR IGNORE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (5,  'phpExtNotInstalled');
INSERT OR IGNORE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (6,  'zendExtDirectiveMismatch');
INSERT OR IGNORE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (7,  'zendExtNotLoaded');
INSERT OR IGNORE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (8,  'zendExtNotInstalled');
INSERT OR IGNORE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (9,  'deploymentFailure');
INSERT OR IGNORE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (10, 'deploymentUpdateFailure');
INSERT OR IGNORE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (11, 'deploymentRedeployFailure');
INSERT OR IGNORE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (12, 'deploymentHealthcheckFailure');
INSERT OR IGNORE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (13, 'deploymentRemoveFailure');
INSERT OR IGNORE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (14, 'deploymentRollbackFailure');
INSERT OR IGNORE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (15, 'deploymentDefineAppFailure');
INSERT OR IGNORE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (16, 'serverAddError');
INSERT OR IGNORE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (17, 'serverRemoveError');
INSERT OR IGNORE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (18, 'serverEnableError');
INSERT OR IGNORE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (19, 'serverDisableError');
INSERT OR IGNORE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (20, 'serverForceRemoveError');
INSERT OR IGNORE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (21, 'jobqueueHighConcurrency');
INSERT OR IGNORE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (22, 'serverRestarting');
INSERT OR IGNORE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (23, 'sessionClusteringWrongHandler');
INSERT OR IGNORE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (26, 'invalidLicense');
INSERT OR IGNORE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (27, 'licenseAboutToExpire');
INSERT OR IGNORE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (28, 'webserverNotResponding');
INSERT OR IGNORE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (29, 'maxServersInCluster');
INSERT OR IGNORE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (30, 'licenseAboutToExpire45');
INSERT OR IGNORE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (31, 'licenseAboutToExpire15');
INSERT OR IGNORE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (32, 'databaseConnectionRestored');
INSERT OR IGNORE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (33, 'sessionClusteringStdbyMode');
INSERT OR IGNORE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (34, 'zendServerDaemonOffline');
INSERT OR IGNORE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (35, 'sessionClusteringErrorMode');
INSERT OR IGNORE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (36, 'mailSettingsError');
INSERT OR IGNORE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (37, 'sessionClusteringShutdownError');
INSERT OR IGNORE INTO ZSD_NOTIFICATIONS_ACTIONS (TYPE, NAME) VALUES (500, 'libraryUpdateAvailable');
