#!/bin/bash
ZSST_PLUGIN_NAME="Configure Apache Core Dumps Creation"


if [ $NONSU ]; then
	echo "You need to be superuser to perform this operation."
	exit 1
fi

if [ "$2" = "--auto" ]; then
	if which zypper > /dev/null 2>&1; then
		AUTOMATIC="-n --gpg-auto-import-keys"
	else
		AUTOMATIC="-y"
	fi
else
	AUTOMATIC=""
fi


. $ZCE_PREFIX/share/support_tool/st_funcs.lib


mkdir $ZCE_PREFIX/var/core
chmod 777 $ZCE_PREFIX/var/core


PHP_VER=`$ZCE_PREFIX/bin/php -i | grep "PHP Version => " | head -1 | cut -d">" -f2 | sed "s@ @@g" | cut -d"." -f1,2`
DBG_PACKAGE_NAMES="php-$PHP_VER-bin-zend-server-dbg zend-server-php-$PHP_VER-dbg"

echo 'core.dump.%p' > /proc/sys/kernel/core_pattern

if which aptitude 2> /dev/null; then
	aptitude $AUTOMATIC install $DBG_PACKAGE_NAMES
	echo "CoreDumpDirectory $ZCE_PREFIX/var/core" > /etc/apache2/conf.d/zend_coredump
elif which apt-get 2> /dev/null; then
	apt-get $AUTOMATIC install $DBG_PACKAGE_NAMES
	echo "CoreDumpDirectory $ZCE_PREFIX/var/core" > /etc/apache2/conf.d/zend_coredump
elif which yum 2> /dev/null; then
	yum $AUTOMATIC install $DBG_PACKAGE_NAMES
	echo "CoreDumpDirectory $ZCE_PREFIX/var/core" > /etc/httpd/conf.d/zend_coredump.conf
elif which zypper 2> /dev/null; then
	zypper $AUTOMATIC install $DBG_PACKAGE_NAMES
	echo "CoreDumpDirectory $ZCE_PREFIX/var/core" > /etc/apache2/conf.d/zend_coredump.conf
else
	echo
	echo "Can't determine which package manager (aptitude, apt-get, yum or zypper) should be used for debug symbols installation"
	exit 1
fi


ulimit -c unlimited


yesnocommand "Confirm restart of Zend Server" "Zend Server needs to be restarted to enable core dumps creation." "$ZCE_PREFIX/bin/zendctl.sh restart"


cat <<EOT


Zend Server and Apache are prepared to save core dumps of crashing processes.
Reproduce the crash and check that core dump files have been placed in

$ZCE_PREFIX/var/core


If you want to "turn off" core dump creation, simply restart Zend Server:

$ZCE_PREFIX/bin/zendctl.sh restart


If you need to restart Zend Server, but keep it in core dump mode, set the proper limit before Zend Server restart:

ulimit -c unlimited
$ZCE_PREFIX/bin/zendctl.sh restart


EOT
