#!/bin/bash
ZSST_PLUGIN_NAME="Zend Server Logs Collector"
exec >> $ZEND_ERROR_LOG 2>&1


ZSST_MAIN_LOGS=$ZEND_DATA_TMPDIR/zend_logs
ZSST_GUI_LOGS=$ZEND_DATA_TMPDIR/lighttpd_logs

# Main logs start
ZSLOGS="$(cat <<EOT
$ZCE_PREFIX/var/log/access.log
$ZCE_PREFIX/var/log/clean_semaphores.log
$ZCE_PREFIX/var/log/codetracing.log
$ZCE_PREFIX/var/log/datacache.log
$ZCE_PREFIX/var/log/deployment.log
$ZCE_PREFIX/var/log/error.log
$ZCE_PREFIX/var/log/gui_vhost_access.log
$ZCE_PREFIX/var/log/gui_vhost_error.log
$ZCE_PREFIX/var/log/jobqueue_ui.log
$ZCE_PREFIX/var/log/jobqueue.log
$ZCE_PREFIX/var/log/jqd.log
$ZCE_PREFIX/var/log/monitor_node.log
$ZCE_PREFIX/var/log/monitor_ui.log
$ZCE_PREFIX/var/log/monitor_zdo.log
$ZCE_PREFIX/var/log/monitor.log
$ZCE_PREFIX/var/log/other_vhosts_access.log
$ZCE_PREFIX/var/log/pagecache.log
$ZCE_PREFIX/var/log/php.log
$ZCE_PREFIX/var/log/sc.log
$ZCE_PREFIX/var/log/scd.log
$ZCE_PREFIX/var/log/statistics.log
$ZCE_PREFIX/var/log/utils.log
$ZCE_PREFIX/var/log/zdd.log
$ZCE_PREFIX/var/log/zem_ui.log
$ZCE_PREFIX/var/log/zem.log
$ZCE_PREFIX/var/log/zs_create_databases.log
$ZCE_PREFIX/var/log/zsd.log
$ZCE_PREFIX/var/log/zs_maintenance.log
EOT
)"

mkdir $ZSST_MAIN_LOGS

if [ $FULLLOGS ]; then

	cp -RL $ZCE_PREFIX/var/log/* $ZSST_MAIN_LOGS/

else

	fcount=0
	while read zslog; do
		if [ -s $zslog ]; then
			tail -n1000 $zslog > $ZSST_MAIN_LOGS/$(basename ${zslog})
			fcount=$(expr $fcount + 1)
		fi
	done <<EOI
$ZSLOGS
EOI

	ls -hAlF $ZCE_PREFIX/var/log/ > $ZSST_MAIN_LOGS/listing.txt
	llines=$(cat $ZSST_MAIN_LOGS/listing.txt | tail -n+2 | wc -l)
	mv $ZSST_MAIN_LOGS/listing.txt "${ZSST_MAIN_LOGS}/${fcount}_of_${llines}.files"

fi
# Main logs end



# GUI Logs
cp -RL $ZCE_PREFIX/gui/lighttpd/logs $ZSST_GUI_LOGS