<?php

abstract class ZServer_Cli_Tool_Command_Abstract
{
	protected $_name		 = '';
	
	protected $_description  = '';
	
	protected $_usageMessage = '';
	
	protected $_args = array();
	
	/**
	 * Tool object
	 * 
	 * @var ZServer_Cli_Tool
	 */
	protected $_tool;
	
	public function __construct($name, ZServer_Cli_Tool $tool)
	{
		$this->_name	= $name;
		$this->_tool	= $tool;
	}
	
	public function getName()
	{
		return $this->_name;
	}
	
	public function getDescription()
	{
		return $this->_description;
	}
	
	public function getUsageMessage()
	{
		return $this->_tool->getName() . " " . $this->_name . " " . $this->_usageMessage;
	}
	
	public function getArguments()
	{
		return $this->_args;
	}
	
	abstract public function run();
}