<?php

class ZServer_Cli_Tool_Command_Manage_ClusterAddServer extends ZServer_Cli_Tool_Command_Manage_Abstract
{
	protected $_description = 'add a new (unbootstrapped) Zend server to Cluster';
	
	protected $_usageMessage = '-n <name> -u <url> [options]';
	
	protected $_args = array(
		'n|name=a'	 => 'name to give new server (required)',
		'u|url=a'	  => 'new server\'s full ZS GUI URL (required)', 
	
		'r|retry=i' => 'retry action <value> times if server is locked; default is 3',
		'w|wait=i'  => 'wait <value> seconds between retires; default is 5'
		);
	
	
	protected function _run()
	{
		$serverName  = $this->_tool->getArguments()->n;
		$serverUrl   = $this->_tool->getArguments()->u;

		$retry = $this->_tool->getArguments()->r;
		$wait  = $this->_tool->getArguments()->w;		
		
		if (! $serverName) {
			throw new ZServer_Cli_Tool_Command_Exception("server name not specified", ZServer_Cli_Tool::EXIT_INVALID_ARG);
		}
		
		if (! $serverUrl) { 
			throw new ZServer_Cli_Tool_Command_Exception("server URL not specified", ZServer_Cli_Tool::EXIT_INVALID_ARG);
		}
		
	   	if ($retry < 1) $retry = 3;  
		if ($wait < 1) $wait = 5;		
		$this->_getZsApiClient()->setRetryIfLocked($retry, $wait);
				
		$serverInfo = $this->_getZsApiClient()->clusterAddServer(
			$serverName,
			$serverUrl
		);
		
		$this->_printServerInfo($serverInfo);
	}
}