<?php

class ZServer_Cli_Tool_Command_Manage_ConfigExport extends ZServer_Cli_Tool_Command_Manage_Abstract
{
    protected $_description = 'export Zend Server configuration to a snapshot file';
    
    protected $_usageMessage = '[options]';
    
    protected $_args = array(
        'f|outfile=a' => 'save to the specified file (default: ZendServerConfig-*.zcfg)',
        's|stdout'    => 'save to stdout (conflicts with -f)' 
    );
    
    protected function _run()
    {
        $outFile = $this->_tool->getArguments()->f;
        $stdout = $this->_tool->getArguments()->s;
        
        if ($stdout) { 
            if ($outFile) {
                throw new ZServer_Cli_Tool_Command_Exception("specify only one of -f and -s, not both", ZServer_Cli_Tool::EXIT_INVALID_ARG);
            }
            $outFile = null;
        } elseif (! $outFile) { 
            $outFile = getcwd();
        }
        
        $outFile = $this->_getZsApiClient()->configurationExport($outFile);
        
        if ($stdout) { 
            $this->_tool->output()->write(file_get_contents($outFile));
            unlink($outFile);
        }
    }
}