<?php

class ZServer_Cli_Tool_Command_Manage_ConfigImport extends ZServer_Cli_Tool_Command_Manage_Abstract
{
    protected $_description = 'import Zend Server configuration from a snapshot file';
    
    protected $_usageMessage = '<snapshot file> [options]';
    
    protected $_args = array(
        'f|force' => 'force importing in case of system configuration conflict',
    );
    
    protected function _run()
    {
        $force = $this->_tool->getArguments()->f;
        
        $args = $this->_tool->getArguments()->getRemainingArgs();
        $inFile = array_shift($args);
        
        if (! $inFile) { 
            // Error: missing input file
            throw new ZServer_Cli_Tool_Command_Exception("no input file was specified", ZServer_Cli_Tool::EXIT_INVALID_ARG);
        }
        
        if (! is_readable($inFile)) {
            // Error: input file is not readable
            throw new ZServer_Cli_Tool_Command_Exception("input file '$inFile' is not readable", ZServer_Cli_Tool::EXIT_INVALID_ARG);
        }
        
        $serversList = $this->_getZsApiClient()->configurationImport($inFile, $force);
        
        foreach($serversList as $serverInfo) {
            $this->_printServerInfo($serverInfo);
        }
    }
}