<?php

class ZServer_Cli_Tool_Command_Manage_RestartPhp extends ZServer_Cli_Tool_Command_Manage_Abstract
{
	protected $_description = 'restart PHP on a server, a set of servers or a cluster';
	
	protected $_usageMessage = '[-p] [server ID] [...]';
	
	protected $_args = array(
		'p|parallel' => 'restart cluster servers in parallel (restart is sequencial by default)'
	);
	
	protected function _run()
	{
		$servers = $this->_tool->getArguments()->getRemainingArgs();
		$parallel = $this->_tool->getArguments()->p;
		
		$serversList = $this->_getZsApiClient()->restartPhp($servers, $parallel);
		
		foreach($serversList as $serverInfo) {
			$this->_printServerInfo($serverInfo);
		}
	}
}