<?php

class ZServer_Cli_Tool_Command_Manage_apiKeysAddKey extends ZServer_Cli_Tool_Command_Manage_Abstract
{
	protected $_description = 'Add api key';
	
	protected $_usageMessage = '-n <web api key name> -u <optional web api key user name (default is admin)>';
	
	protected $_args = array(
			'n|name=s'	 	=> 'Web api key name',
			'u|userName-s'	=> 'Web api key user name',
			's|se-s'			=> '',
	);
	
	protected function _run()
	{
		$keyName  = $this->_tool->getArguments()->n;
		if (!$keyName) {
			throw new ZServer_Cli_Tool_Command_Exception("key name not specified", ZServer_Cli_Tool::EXIT_INVALID_ARG);
		} elseif ($keyName=='admin')	throw new ZServer_Cli_Tool_Command_Exception("key name cannot be 'admin'", ZServer_Cli_Tool::EXIT_INVALID_ARG);

		$keyUserName  = $this->_tool->getArguments()->u;
		if (!isset($keyUserName)) {
			$keyUserName="admin";
		}
		$keyHash  = $this->_tool->getArguments()->s;
		if (isset ($keyHash) && strlen($keyHash) !== 64) throw new ZServer_Cli_Tool_Command_Exception("Error argument -s ", ZServer_Cli_Tool::EXIT_INVALID_ARG);
		$args['name']=$keyName;
		$args ['username'] = $keyUserName;
		$args ['hash'] = $keyHash;
		$response = $this->_getZsApiClient()->apiKeysAddKey($args);
		$output="KEY_NAME = {$response->name}\nKEY_USER_NAME = {$response->username}\nKEY_HASH = {$response->hash}\n";
		$this->_tool->output()->write($output);
	}
}