<?php

class ZServer_Cli_Tool_Command_Manage_applicationSynchronize extends ZServer_Cli_Tool_Command_Manage_Abstract
{
    protected $_description = 'Synchronize an application on a server, a set of servers or a cluster';

	protected $_usageMessage = '-i <appId>  [server ID] [options]';
    
	protected $_args = array(
    	'i|id=i'     		=> 'Application ID to synchronize (required)',
	);    
    
    
    protected function _run()
    {
    	if (!isset($this->_tool->getArguments()->i)) {    		
    		throw new ZServer_Cli_Tool_Command_Exception("appId not specified", ZServer_Cli_Tool::EXIT_INVALID_ARG);
    	}
    	
    	$appId = (integer) $this->_tool->getArguments()->i;    	
    	$servers = $this->_tool->getArguments()->getRemainingArgs();    	
		$serverInfo = $this->_getZsApiClient()->applicationSynchronize($appId, $servers);
		$this->_printApplicationInfo($serverInfo);
    }
}