<?php

class ZServer_Cli_Tool_Command_Manage_clusterReconfigureServer extends ZServer_Cli_Tool_Command_Manage_Abstract
{
    protected $_description = 'Reconfigure a cluster member to match the cluster\'s profile';
    
    protected $_usageMessage = '<server ID> [options]';
    
    protected $_args = array(
    	'd|doRestart' => 'Should the reconfigured server be restarted after the reconfigure action. Default is FALSE',
    );
    
    protected function _run()
    {
        //$doRestart = (boolean) $this->_tool->getArguments()->d;
        
        $args = $this->_tool->getArguments()->getRemainingArgs();
        $serverId = (int) array_shift($args);
        
        if (! is_int($serverId)) { 
            // Error: missing server ID
            throw new ZServer_Cli_Tool_Command_Exception("missing or invalid server ID", ZServer_Cli_Tool::EXIT_INVALID_ARG);
        }
        
        if (! empty($args)) {
            // Error: too many arguments
            throw new ZServer_Cli_Tool_Command_Exception("unexpected number of arguments, expecting exactly one argument", ZServer_Cli_Tool::EXIT_INVALID_ARG);
        }
        
        $serverInfo = $this->_getZsApiClient()->clusterReconfigureServer($serverId, $doRestart);
        
        $this->_printServerInfo($serverInfo);
    }
}