<?php

class ZServer_Cli_Tool_Command_Manage_configurationStoreDirectives extends ZServer_Cli_Tool_Command_Manage_Abstract
{
	protected $_description = 'Change directive value';
	
	protected $_usageMessage = '-d <Directive name> -v <directive new value>';
	
	protected $_args = array(
			'd|directiveName=s'	 	=> 'Full directive name',
			'v|directiveValue=s'	=> 'Directive new value',
	);
	
	protected function _run()
	{
		$directiveName  = $this->_tool->getArguments()->d;
		if (!$directiveName) {
			throw new ZServer_Cli_Tool_Command_Exception("Directive name not specified", ZServer_Cli_Tool::EXIT_INVALID_ARG);
		}	

		$directiveValue  = $this->_tool->getArguments()->v;
		if (!isset($directiveValue)) {
			throw new ZServer_Cli_Tool_Command_Exception("Directive Value not specified", ZServer_Cli_Tool::EXIT_INVALID_ARG);
		}
		$args['directives'][$directiveName] = $directiveValue;
		$directives = $this->_getZsApiClient()->configurationStoreDirectives($args);
		$output="";
		foreach($directives as $directive) {
			$output .= "Directive " . $directive->directive->name . " in " . $directive->directive->context . " " . $directive->directive->contextName . " changed successfully\n";
		}
		$output .= "You should restart php or any other components affected by this change";
		$this->_tool->output()->write($output);
	}
}