<?php

class ZServer_Cli_Tool_Command_Manage_libraryRemove extends ZServer_Cli_Tool_Command_Manage_Abstract
{
    protected $_description = 'Remove a Library with all its versions';

	protected $_usageMessage = '-i library ID [options]';
    
	protected $_args = array(
		'i|libid=i'     	=> 'library  ID',
    );    
    
    
    protected function _run()
    {
		$libId  = $this->_tool->getArguments()->i;
		
		if (!$libId) { 
			throw new ZServer_Cli_Tool_Command_Exception("library ID not specified", ZServer_Cli_Tool::EXIT_INVALID_ARG);
		}
        
		$libraryInfo = $this->_getZsApiClient()->libraryRemove($libId);
		$output=$this->_printLibraryInfo($libraryInfo);
		$this->_tool->output()->write($output);
    }
}