<?php

class ZServer_Cli_Tool_Command_Manage_libraryVersionDeploy extends ZServer_Cli_Tool_Command_Manage_Abstract
{
    protected $_description = 'deploy a Library';

	protected $_usageMessage = '-p <pkgFile> [options]';
    
	protected $_args = array(
		'p|pkgFile=s'     	=> 'full path to the package file (required)',
    );    
    
    
    protected function _run()
    {
		$pkgFile  = $this->_tool->getArguments()->p;
		
		if (!$pkgFile) { 
			throw new ZServer_Cli_Tool_Command_Exception("pkgFile not specified", ZServer_Cli_Tool::EXIT_INVALID_ARG);
		}
    	
		if (!is_file($pkgFile)) { 
			throw new ZServer_Cli_Tool_Command_Exception("pkgFile [$pkgFile] is not a valid file", ZServer_Cli_Tool::EXIT_INVALID_ARG);
		}
		    		
        
		$libraryInfo = $this->_getZsApiClient()->libraryVersionDeploy($pkgFile);
		$output=$this->_printLibraryInfo($libraryInfo);
		$this->_tool->output()->write($output);
    }
}