<?php

class ZServer_Cli_Tool_Command_Manage_libraryVersionRemove extends ZServer_Cli_Tool_Command_Manage_Abstract
{
    protected $_description = 'Remove a Library version';

	protected $_usageMessage = '-i library version ID [options]';
    
	protected $_args = array(
		'i|libid=i'     	=> 'library version ID',
    );    
    
    
    protected function _run()
    {
		$libVerId  = $this->_tool->getArguments()->i;
		
		if (!$libVerId) { 
			throw new ZServer_Cli_Tool_Command_Exception("library version ID not specified", ZServer_Cli_Tool::EXIT_INVALID_ARG);
		}
        
		$libraryInfo = $this->_getZsApiClient()->libraryVersionRemove($libVerId);
		$output=$this->_printLibraryInfo($libraryInfo);
		$this->_tool->output()->write($output);
    }
}