<?php

class ZServer_Cli_Tool_Command_Setup_ListApiKeys extends ZServer_Cli_Tool_Command_Abstract
{
    protected $_description = 'list all API keys available on this system';
    
    protected $_usageMessage = '[options]';
    
    protected $_args = array(
        's|showkey' => 'show secret keys; if not specified actual key values remain hidden'
    );
    
    public function run()
    {
        // Set the new password
        $this->_showKeys((bool) $this->_tool->getArguments()->s);
    }
    
    protected function _showKeys($showSecret)
    {
        $keyRing = new Api_Auth_Keyring();
        $keys = $keyRing->getKeys();
        
        foreach($keys as $key) {
            $this->_tool->output()->write(
                ZServer_Cli_Tool_Command_Setup_ShowApiKey::printApiKeyDetails($key, $showSecret)
            );
        }            
    }
}