<?php

class ZServer_Cli_Tool_Command_Setup_RevokeApiKey extends ZServer_Cli_Tool_Command_Abstract
{
    const EXIT_UNKNOWN_KEY = 51;
    
    protected $_description = 'revoke and delete an API key';
    
    protected $_usageMessage = '<key name>';
    
    public function run()
    {
        $args = $this->_tool->getArguments()->getRemainingArgs();
        $keyName = array_shift($args);
        
        if (! $keyName) { 
            // Error: missing order number
            throw new ZServer_Cli_Tool_Command_Exception("key name not specified. Run with --help for usage information", ZServer_Cli_Tool::EXIT_INVALID_ARG);
        }
        
        if (! empty($args)) {
            // Error: too many arguments
            throw new ZServer_Cli_Tool_Command_Exception("unexpected number of arguments, expecting only one argument", ZServer_Cli_Tool::EXIT_INVALID_ARG);
        }
        
        $this->_revokeKey($keyName);
    }
    
    protected function _revokeKey($keyName)
    {
        $keyRing = new Api_Auth_Keyring();
        
        if (! $keyRing->revokeKey($keyName)) {
            $this->_tool->output()->debug("revokeKey on '$keyName' returned false");
            throw new ZServer_Cli_Tool_Command_Exception("unable to revoke key '$keyName'. Does it exist?", self::EXIT_UNKNOWN_KEY);
        }
    }
}