<?php

class ZServer_Cli_Tool_Command_Setup_SetPassword extends ZServer_Cli_Tool_Command_Abstract
{
    protected $_description = 'set the Zend Server GUI password';
    
    protected $_usageMessage = '<new password>';
    
    public function run()
    {
        $args = $this->_tool->getArguments()->getRemainingArgs();
        $password = array_shift($args);
        
        if (! $password) { 
            // Error: missing password
            throw new ZServer_Cli_Tool_Command_Exception("missing required password argument", ZServer_Cli_Tool::EXIT_INVALID_ARG);
        }
        
        if (! empty($args)) {
            // Error: too many arguments
            throw new ZServer_Cli_Tool_Command_Exception("unexpected number of arguments, expecting a single password argument", ZServer_Cli_Tool::EXIT_INVALID_ARG);
        }
        
        // Set the new password
        $this->_setPassword($password);
    }
    
    /**
     * Set the new password
     * 
     * @param string $password
     */
    protected function _setPassword($password)
    {
        Common_ApplicationModel::savePassword($password, $password);
    }
}