<?php

class ZServer_Cli_Tool_Manage extends ZServer_Cli_Tool 
{
	protected $_toolName = 'zs-manage';
	
	protected $_toolDescription = 'Manage Zend Server using the Web API';
	
	protected $_commandClasses = array(
		
		'app-get-status'			=> 'ZServer_Cli_Tool_Command_Manage_applicationGetStatus',	
		'app-deploy'				=> 'ZServer_Cli_Tool_Command_Manage_applicationDeploy',  
		'app-synchronize'			=> 'ZServer_Cli_Tool_Command_Manage_applicationSynchronize', 
		'app-remove'				=> 'ZServer_Cli_Tool_Command_Manage_applicationRemove',
		'app-update'	        	=> 'ZServer_Cli_Tool_Command_Manage_applicationUpdate',
	    'app-rollback'	        	=> 'ZServer_Cli_Tool_Command_Manage_applicationRollback',
		
		'library-deploy'			=> 'ZServer_Cli_Tool_Command_Manage_libraryVersionDeploy',
		'library-version-remove'	=> 'ZServer_Cli_Tool_Command_Manage_libraryVersionRemove',
		'library-remove'			=> 'ZServer_Cli_Tool_Command_Manage_libraryRemove',
		'library-get-status'		=> 'ZServer_Cli_Tool_Command_Manage_libraryGetStatus',
			
		'bootstrap-single-server'   => 'ZServer_Cli_Tool_Command_Manage_bootstrapSingleServer',
		'cluster-list-servers' 	 	=> 'ZServer_Cli_Tool_Command_Manage_ClusterListServers',
		'server-add-to-cluster'		=> 'ZServer_Cli_Tool_Command_Manage_serverAddToCluster',
		'store-directive'			=> 'ZServer_Cli_Tool_Command_Manage_configurationStoreDirectives',
		'cluster-add-server'		=> 'ZServer_Cli_Tool_Command_Manage_ClusterAddServer',
		'cluster-remove-server' 	=> 'ZServer_Cli_Tool_Command_Manage_ClusterRemoveServer',
		'cluster-enable-server' 	=> 'ZServer_Cli_Tool_Command_Manage_ClusterEnableServer',
		'cluster-disable-server'	=> 'ZServer_Cli_Tool_Command_Manage_ClusterDisableServer',
		'cluster-reconfig-server'	=> 'ZServer_Cli_Tool_Command_Manage_clusterReconfigureServer',
		'api-keys-add-key'			=> 'ZServer_Cli_Tool_Command_Manage_apiKeysAddKey',
		'config-export'		 		=> 'ZServer_Cli_Tool_Command_Manage_ConfigExport',
		'config-import'		 		=> 'ZServer_Cli_Tool_Command_Manage_ConfigImport',
	
		'restart-php'				=> 'ZServer_Cli_Tool_Command_Manage_RestartPhp',
		'system-info'		   		=> 'ZServer_Cli_Tool_Command_Manage_SystemInfo',
			
	);
	
	protected $_toolArgs = array(
		'N|key-name=s'   => 'Web API key name (required)',
		'K|secret-key=s' => 'Web API secret key (required)',
		'U|server-url=s' => 'Zend Server URL (optional, default is http://localhost:10081/ZendServer)' 
	);
}